unit Displayl; { light (aka text) version }

interface
uses types,
     sysutils,
     crt;
     


const
  PlayerCols:array[0..MAX_PLAYERS] of byte=
        ( lightgray, lightred, lightgreen, lightblue, yellow, white, white, white, white ); 

  FoodCols:array[1..7] of byte = (yellow, lightblue, lightgreen, lightred, lightcyan, lightgray, white);


const first:boolean = true;
      need_cls: boolean = false;

function IntToStr(i:longint):string;

procedure disp_Init;
procedure disp_Done;

procedure BeforeGame;
procedure AfterGame;

procedure ClearScreen;
procedure ClearStatus;

function kdelay(t:longint):boolean;

procedure ShowPlan(data:Pdata);
procedure ShowData(data:Pdata; pl:integer);
procedure ShowView(view:Tview; dy:integer);

{
procedure ShowPlayer(dir: integer; p:real; lst, nst:integer; pst: real; pl:integer);
procedure HidePlayer(dir: integer; p:real; lst, nst:integer; pst: real; pl:integer);
}

implementation
uses vars;

function IntToStr(i:longint):string;
var s:string;
begin
  Str(i,s);
  IntToStr:=s;
end;

procedure disp_Init;
begin
  clrscr;
end;

procedure disp_Done;
begin
  textattr:=7;
  clrscr;
end;

procedure BeforeGame;
begin
end;

procedure AfterGame;
begin
end;

procedure ClearScreen;
begin
  clrscr;
end;

procedure ClearStatus;
begin
end;

function kdelay(t:longint):boolean;
begin
  kdelay:=false;
  while t>0 do
  begin
    delay(100);
    dec(t,100);
    if keypressed then
    begin
      kdelay:=true;
      break;
    end;
  end;
end;

procedure Put(var dest:string; s:String; a1,a2:byte);
begin
  dest:=dest+char(a1)+s[1]+char(a2)+s[2];
end;

procedure ShowPlan(data:Pdata);
var x,y: integer;
    l: longint;
    a,b: byte;
    c,d: char;
    s: string;
begin
  for y:=1 to MAX_PLAN_Y do
  begin
    gotoxy(1,y);
    for x:=1 to MAX_PLAN_X do
    begin
      l:=data^.plan[x,y];
      s:='';
      
      if l and vStena<>0 then Put(s,'##',$77,$77)
      else
      begin
        c:=' '; a:=$07;
	d:=' '; b:=$07;
	
	if l and vfAny<>0 then c:='.';	
	if l and vfTyckova<>0 then a:=FoodCols[6];
	if l and vfOtaznik<>0 then a:=FoodCols[7];
	if l and vfZrava<>0 then a:=FoodCols[2];
	if l and vfTehlova<>0 then a:=FoodCols[3];
	if l and vfZmetena<>0 then a:=FoodCols[4];
	if l and vfNeviditelna<>0 then a:=FoodCols[5];
        if l and vfZlata<>0 then begin a:=FoodCols[1]; c:='*'; end;
	
	if l and vPlayer1<>0 then begin b:=PlayerCols[1]; d:='1'; end;
	if l and vPlayer2<>0 then begin b:=PlayerCols[2]; d:='2'; end;
	if l and vPlayer3<>0 then begin b:=PlayerCols[3]; d:='3'; end;
	if l and vPlayer4<>0 then begin b:=PlayerCols[4]; d:='4'; end;
	if l and vSlimak<>0 then begin b:=$0F; d:='S'; end;

 
	
	Put(s,d+c,b,a);
      end;
      Put(s,'  ',$07,$07);
      
      textattr:=byte(s[1]); write(s[2]);
      textattr:=byte(s[3]); write(s[4]);
{      textattr:=0; write(' '); }
    end;
  end;
  
  textattr:=$07;
  writeln;
end;

procedure ShowView(view:Tview;dy:integer);
var x,y: integer;
    l: longint;
    a,b: byte;
    c,d: char;
    s: string;
begin
  for y:=-MAX_VIEW to MAX_VIEW do
  begin
    gotoxy(80-5*MAX_VIEW,y+dy+MAX_VIEW);
    for x:=-MAX_VIEW to MAX_VIEW do
    begin
      l:=view.view[x,y];
      s:='';
      
      if l and vStena<>0 then Put(s,'##',$77,$77)
      else
      begin
        c:=' '; a:=$07;
	d:=' '; b:=$07;
	
	if l and vfAny<>0 then c:='.';	
	if l and vfTyckova<>0 then a:=FoodCols[6];
	if l and vfOtaznik<>0 then a:=FoodCols[7];
	if l and vfZrava<>0 then a:=FoodCols[2];
	if l and vfTehlova<>0 then a:=FoodCols[3];
	if l and vfZmetena<>0 then a:=FoodCols[4];
	if l and vfNeviditelna<>0 then a:=FoodCols[5];
        if l and vfZlata<>0 then begin a:=FoodCols[1]; c:='*'; end;
	
	if l and vPlayer1<>0 then begin b:=PlayerCols[1]; d:='1'; end;
	if l and vPlayer2<>0 then begin b:=PlayerCols[2]; d:='2'; end;
	if l and vPlayer3<>0 then begin b:=PlayerCols[3]; d:='3'; end;
	if l and vPlayer4<>0 then begin b:=PlayerCols[4]; d:='4'; end;
	if l and vSlimak<>0 then begin b:=$0F; d:='S'; end;

 
	
	Put(s,d+c,b,a);
      end;
      Put(s,'  ',$07,$07);
      
      textattr:=byte(s[1]); write(s[2]);
      textattr:=byte(s[3]); write(s[4]);
{      textattr:=0; write(' '); }
    end;
  end;

  textattr:=$07;
end;

procedure WriteChar(a:byte;c:char);
begin
  textattr:=a;
  write(c);
end;

procedure ShowFoodAt(data:Pdata; x,y:integer);
begin
  if data^.plan[x,y] and vfZlata<>0 then WriteChar(FoodCols[1],'*');
  if data^.plan[x,y] and vfZrava<>0 then WriteChar(FoodCols[2],'.');
  if data^.plan[x,y] and vfTehlova<>0 then WriteChar(FoodCols[3],'.');
  if data^.plan[x,y] and vfZmetena<>0 then WriteChar(FoodCols[4],'.');
  if data^.plan[x,y] and vfNeviditelna<>0 then WriteChar(FoodCols[5],'.');
  if data^.plan[x,y] and vfTyckova<>0 then WriteChar(FoodCols[6],'*');
  if data^.plan[x,y] and vfOtaznik<>0 then WriteChar(FoodCols[7],'.');
end;

procedure ShowData(data:Pdata; pl:integer);
begin
  gotoxy(42,6*(pl-1)+1);
  textattr:=$07; write(data^.pl[pl].name,'(',data^.pl[pl].left,') : ',data^.pl[pl].score,'   ');
  
  gotoxy(42,6*(pl-1)+2); 
  textattr:=FoodCols[2]; write('Zr:',data^.pl[pl].nZrava);
  textattr:=FoodCols[4]; write(' Zm:',data^.pl[pl].nZmetena);
  textattr:=FoodCols[5]; write(' Ne:',data^.pl[pl].nNeviditelna);
  textattr:=FoodCols[3]; write(' Te:',data^.pl[pl].nTehlova,'    ');
	
  gotoxy(42,6*(pl-1)+3); write('Up:             '); gotoxy(42,6*(pl-1)+3); 
  textattr:=$07; write('Up:   ');
  ShowFoodAt(data,data^.pl[pl].x,data^.pl[pl].y-1);
  
  gotoxy(50,6*(pl-1)+3); write('Down:           '); gotoxy(50,6*(pl-1)+3); 
  textattr:=$07; write('Down: ');
  ShowFoodAt(data,data^.pl[pl].x,data^.pl[pl].y+1);

  gotoxy(42,6*(pl-1)+4); write('Left:           '); gotoxy(42,6*(pl-1)+4); 
  textattr:=$07; write('Left: ');
  ShowFoodAt(data,data^.pl[pl].x-1,data^.pl[pl].y);
  
  gotoxy(50,6*(pl-1)+4); write('Right:          '); gotoxy(50,6*(pl-1)+4);
  textattr:=$07; write('Right:');
  ShowFoodAt(data,data^.pl[pl].x+1,data^.pl[pl].y);
  
  textattr:=$07; write(' ');
end;

{
procedure ShowPlayer(dir: integer; p:real; lst, nst:integer; pst: real; pl:integer);
begin
end;

procedure HidePlayer(dir: integer; p:real; lst, nst:integer; pst: real; pl:integer);
begin
end;
}

end.
