unit Slimak2; { mySli-Mak (c) MisoF }

{$DEFINE MFDEBUG}

interface
uses Types;

const plUnknown = 0;
      plEmpty = 1;
      plFull = -1;
      
type TMyPlayer = object(TDefaultPlayer)
			constructor Init;
			destructor Done;
			
			{ zaciatok kazdej hry }
			procedure InitGame(id: integer); virtual;
					   
			{ znovunarodenie (i.e. po InitGame a po kazdom zozrati }
			procedure Born(I_see: Tview); virtual;
			
			{ po zozrati }
			procedure Eaten(I_saw: Tview); virtual;
			
			{ jeden tah }
			function FindShortestPath(xs,ys,xf,yf : integer) : integer;
			procedure MakeMove(I_see: Tview; var command: integer); virtual;

			private
                          kolo,myid: longint;
		      end;
     PMyPlayer = ^TMyPlayer;

var plan: array[-MAX_VIEW+1..MAX_PLAN_X+MAX_VIEW,-MAX_VIEW+1..MAX_PLAN_Y+MAX_VIEW] of longint;
    { abs je kolo kedy to bolo videne }
    { sgn je typ }
    lastsaw,we : array[1..4] of record
                    kolo,x,y: longint;
                 end;
    

implementation

function sgn(x : longint) : longint;
begin 
   if x>0 then begin sgn:=1; exit; end; 
   if x=0 then begin sgn:=0; exit; end; 
   if x<0 then begin sgn:=-1; exit; end; 
end;

constructor TMyPlayer.Init; 
begin 
  name:='mySli-Mak 1.147';
  {
   nomen omen:
   ... slim\''ak
   ... mysli
   ... my [ma:j]
   ... m\""usli, mak
   ... S-M
   ... M\''ak [Mrakoplas]
   ... mysl\''\im, ak 1.147 [cize myslim, lebo len 0 je false :-]
   ... Kamil slimak [=kamils limaK]
   ... 47
  }
  message:=''; 
end;

destructor TMyPlayer.Done; 
begin 
end;

procedure TMyPlayer.InitGame(id: integer); 
var i,j : integer;
begin 
  kolo:=0;
  myid:=id; 
  if (id=5) then { prvy slimak nuluje we ;) }
     for i:=1 to 4 do begin
        we[i].x:=MAX_PLAN_X div 2;
        we[i].y:=MAX_PLAN_Y div 2;
     end;
  if (id=6) then { druhy slimak nuluje lastsaw ;) }
     for i:=1 to 4 do begin
        lastsaw[i].kolo:=-2;
        lastsaw[i].x:=-2;
        lastsaw[i].y:=-2;
     end;
  if (id=7) then { treti slimak nuluje mapu ;) }
     for i:=-MAX_VIEW+1 to MAX_PLAN_X+MAX_VIEW do 
        for j:=-MAX_VIEW+1 to MAX_PLAN_Y+MAX_VIEW do
           if (i<1) or (j<1) or (i>MAX_PLAN_X) or (j>MAX_PLAN_Y) then 
                plan[i,j]:=plFull 
           else plan[i,j]:=plUnknown;
  { a stvrty slimak sa zatial flaka :-P }
end;

procedure TMyPlayer.Born(I_see: Tview); 
begin 
end;

procedure TMyPlayer.Eaten(I_saw: Tview); 
begin 
end;

function TMyPlayer.FindShortestPath(xs,ys,xf,yf : integer) : integer;
var dist,from: array[-MAX_VIEW+1..MAX_PLAN_X+MAX_VIEW,-MAX_VIEW+1..MAX_PLAN_Y+MAX_VIEW] of longint;
    fro:array[0..MAX_PLAN_X*MAX_PLAN_Y,0..1] of longint;
    i,j,froz,frok,fromax,kdex,kdey : longint;

begin
{   writeln(stderr,'Zacinam hladat shortest path.');}
   fromax:=MAX_PLAN_X*MAX_PLAN_Y;
   froz:=0; frok:=1;
   fro[0,0]:=xf; fro[0,1]:=yf;
   for i:=1 to MAX_PLAN_X do
      for j:=1 to MAX_PLAN_Y do
         dist[i,j]:=100000000;
   dist[xf,yf]:=0;

   while (froz<>frok) do begin
      kdex:=fro[froz,0]; kdey:=fro[froz,1];
{      writeln(stderr,'Skusam ist na ',kdex,' ',kdey);}
      froz:=(froz+1) mod fromax;
      if (sgn(plan[kdex-1,kdey])<>plFull) and (dist[kdex-1,kdey]>dist[kdex,kdey]+1) then begin
         fro[frok,0]:=kdex-1; fro[frok,1]:=kdey; frok:=(frok+1) mod fromax;
         dist[kdex-1,kdey]:=dist[kdex,kdey]+1;
         from[kdex-1,kdey]:=1;
      end;
      if (sgn(plan[kdex+1,kdey])<>plFull) and (dist[kdex+1,kdey]>dist[kdex,kdey]+1) then begin
         fro[frok,0]:=kdex+1; fro[frok,1]:=kdey; frok:=(frok+1) mod fromax;
         dist[kdex+1,kdey]:=dist[kdex,kdey]+1;
         from[kdex+1,kdey]:=2;
      end;
      if (sgn(plan[kdex,kdey-1])<>plFull) and (dist[kdex,kdey-1]>dist[kdex,kdey]+1) then begin
         fro[frok,0]:=kdex; fro[frok,1]:=kdey-1; frok:=(frok+1) mod fromax;
         dist[kdex,kdey-1]:=dist[kdex,kdey]+1;
         from[kdex,kdey-1]:=3;
      end;
      if (sgn(plan[kdex,kdey+1])<>plFull) and (dist[kdex,kdey+1]>dist[kdex,kdey]+1) then begin
         fro[frok,0]:=kdex; fro[frok,1]:=kdey+1; frok:=(frok+1) mod fromax;
         dist[kdex,kdey+1]:=dist[kdex,kdey]+1;
         from[kdex,kdey+1]:=4;
      end;
   end;
   
{   for j:=1 to MAX_PLAN_Y do begin
      for i:=1 to MAX_PLAN_X do begin
         case from[i,j] of
            0 : write(stderr,'.');
            1 : write(stderr,'>');
            2 : write(stderr,'<');
            3 : write(stderr,'v');
            4 : write(stderr,'^');
         end;
      end;
      writeln(stderr);
   end;}

      
   if dist[xs,ys]<10000000 then begin
      case from[xs,ys] of
         3 : FindShortestPath:=cmdChodDole;
         4 : FindShortestPath:=cmdChodHore;
         1 : FindShortestPath:=cmdChodVpravo;
         2 : FindShortestPath:=cmdChodVlavo;
      end;
   end else begin
{      case random(4) of 
         0 : FindShortestPath:=cmdChodHore;
         1 : FindShortestPath:=cmdChodDole;
         2 : FindShortestPath:=cmdChodVpravo;
         3 : FindShortestPath:=cmdChodVlavo;
      end;}
      FindShortestPath:=cmdNic;
   end;
{   writeln(stderr,'Nasiel shortest path.');}
end;

procedure TMyPlayer.MakeMove(I_see: Tview; var command: integer); 
var i,j,k,x,y,max,kto,kamx,kamy:integer;
    dist,tdist:longint;
begin 
   inc(kolo);
   command:=cmdNic;

   { updatneme si mapu, co vlastne vidime -- plochu, hracov }
   x:=I_see.x; Y:=I_see.y;
   for i:=-MAX_VIEW to MAX_VIEW do 
      for j:=-MAX_VIEW to MAX_VIEW do begin
         if (I_see.view[i,j] and vStena=0) then plan[x+i,y+j]:=plEmpty*kolo
            else plan[x+i,y+j]:=plFull*kolo;
         if (I_see.view[i,j] and vPlayer1>0) then 
            begin lastsaw[1].kolo:=kolo; lastsaw[1].x:=x+i; lastsaw[1].y:=y+j; end;
         if (I_see.view[i,j] and vPlayer2>0) then 
            begin lastsaw[2].kolo:=kolo; lastsaw[2].x:=x+i; lastsaw[2].y:=y+j; end;
         if (I_see.view[i,j] and vPlayer3>0) then 
            begin lastsaw[3].kolo:=kolo; lastsaw[3].x:=x+i; lastsaw[3].y:=y+j; end;
         if (I_see.view[i,j] and vPlayer4>0) then 
            begin lastsaw[4].kolo:=kolo; lastsaw[4].x:=x+i; lastsaw[4].y:=y+j; end;
      end;

  { ak niekto vidi hraca, vyberieme sa smerom k tomu policku }
  dist:=maxlongint; kto:=0;
  for i:=1 to 4 do begin
     if kolo-lastsaw[i].kolo<=1 then begin
        tdist:=0;
        for j:=1 to 4 do tdist:=tdist+abs(lastsaw[i].x-we[j].x)+abs(lastsaw[i].y-we[j].x);
        if (tdist<dist) then begin dist:=tdist; kto:=i; end;
     end;
  end;
  if (kto>0) then begin
     command:=FindShortestPath(x,y,lastsaw[kto].x,lastsaw[kto].y);
     if command<>cmdNic then begin
        {$IFDEF MFDEBUG}
        writeln(stderr,myid,': idem v kole ',kolo,' za clovekom ',kto,' (command=',command,')');
        {$ENDIF}
        exit;
     end;
  end;
  
   { ak nie, ideme k najblizsiemu neznamemu policku }
   dist:=maxlongint;
   for i:=1 to MAX_PLAN_X do 
      for j:=1 to MAX_PLAN_Y do begin
         if plan[i,j]=plUnknown then begin
            if abs(x-i)+abs(y-j)<dist then begin
               kamx:=i; kamy:=j; dist:=abs(x-i)+abs(y-j);
            end;
         end;
      end;
   if dist<maxlongint then begin
      command:=FindShortestPath(x,y,kamx,kamy);
      if command<>cmdNic then begin
         {$IFDEF MFDEBUG}
         writeln(stderr,myid,': idem v kole ',kolo,' na volne miesto ',kamx,' ',kamy,' (command=',command,')');
         {$ENDIF}
         exit;
      end;
   end;
 
   { a ak ani take nie je, tak ideme nahodne }
   max:=0;
   repeat
      if ((I_see.view[0,-1] and vStena=0) and (random(7)=1)) then command:=cmdChodHore;
      if ((I_see.view[1,0] and vStena=0) and (random(7)=1)) then command:=cmdChodVpravo;
      if ((I_see.view[0,1] and vStena=0) and (random(7)=1)) then command:=cmdChodDole;
      if ((I_see.view[-1,0] and vStena=0) and (random(7)=1)) then command:=cmdChodVlavo;
      inc(max);
   until ((command<>cmdNic) or (max>100));
   
   {$IFDEF MFDEBUG}
   writeln(stderr,myid,': idem v kole ',kolo,' nahodnym smerom ',command);
   {$ENDIF}
 
end;
 
begin
  RegisterPlayer(New(PMyPlayer,Init));
  RegisterPlayer(New(PMyPlayer,Init));
  RegisterPlayer(New(PMyPlayer,Init));
  RegisterPlayer(New(PMyPlayer,Init));
end.
