unit Types;

interface

const 
    MAX_PLAYERS 	= 4+4;

    MAX_PLAN_X  	= 20;
    MAX_PLAN_Y  	= 20;
    MAX_GAMES		= 1;
    MAX_ROUNDS		= 200;

    MAX_VIEW    	= 2;   { -> 5x5 }

    MAX_HITS		= 3;

    PROP_WALLS		= 0.33;
    PROP_FOOD		= 0.25;
      
    DUR_Zrava  		= 7;
    DUR_Zmetena 	= 7;
    DUR_Neviditelna 	= 7;
    
    VAL_Zlata		= 1;
    VAL_Tyckova		= 3;

const
    { vselico }
    vNic		= $00000000;
    vStena		= $00000001;
    vSlimak		= $00000002;
    
    { fazulky }
    fTypes		= 7;
    vfAny		= $00000FF0;
    vfZlata		= $00000010;
    vfZrava		= $00000020;
    vfTehlova		= $00000040;
    vfZmetena		= $00000080;
    vfNeviditelna	= $00000100;
    vfTyckova		= $00000200;
    vfOtaznik		= $00000400;
    
    { hraci }
    vPlayer		= $0F000000;   
    vNiekto		= $0F000002;   { nejaky player alebo slimak }
    
    vPlayer1		= $01000000;
    vPlayer2		= $02000000;
    vPlayer3		= $04000000;
    vPlayer4		= $08000000;
    
    { prikazy }
    cmdNic		= 0;
    
    cmdChodHore		= 1;
    cmdChodVpravo	= 2;
    cmdChodDole		= 3;
    cmdChodVlavo	= 4;
    
    cmdTehlujHore	= 5;
    cmdTehlujVpravo	= 6;
    cmdTehlujDole	= 7;
    cmdTehlujVlavo	= 8;

type
    Tview = record
	      x,y: integer;    { absolute coordinates; [1,1] -> upper left corner }
	      view: array[-MAX_VIEW..MAX_VIEW, -MAX_VIEW..MAX_VIEW] of longint;
	    end;
      
type TDefaultPlayer = object
		        name: string;   { name of the player }
			
			chars_left: integer;
			message: string;        { message sending }
			
			constructor Init;
			destructor Done;
			
			{ zaciatok kazdej hry }
			procedure InitGame(id: integer); virtual;
					   
			{ znovunarodenie (i.e. po InitGame a po kazdom zozrati }
			procedure Born(I_see: Tview); virtual;
			
			{ po zozrati }
			procedure Eaten(I_saw: Tview); virtual;
			
			{ jeden tah }
			procedure MakeMove(I_see: Tview; var command: integer); virtual;

		      end;
     PDefaultPlayer = ^TDefaultPlayer;


type Tdata = record
	       players: integer;        { pocet hracov }
	       pl: array[1..MAX_PLAYERS] of 
	             record
		       obj: PDefaultPlayer;
		       x,y: integer;
		       left: integer;   { pocet zivotov }
		       cmd: integer;
		       dir: integer;    { posledny znamy smer }
		       
		       nZrava,   	{ kolko tahov moze zrat }
		       nZmetena, 	{ kolko tahov bude zmeteny }
		       nNeviditelna, 	{ kolko tahov este bude neviditelny }
		       nTehlova: integer; { kolkokrat moze tehlovat }
		       
		       name: string;
		       score: longint;
		     end;  
		     
	       plan: array[-MAX_VIEW+1..MAX_PLAN_X+MAX_VIEW,-MAX_VIEW+1..MAX_PLAN_Y+MAX_VIEW] of longint;
	     end;
     Pdata = ^Tdata;


procedure RegisterPlayer(pl:PDefaultPlayer);
procedure RegisterAll(s:string);
procedure Error(s:string);

implementation
uses vars;
var reg_items:integer;
    reg_item:array[1..MAX_PLAYERS] of PDefaultPlayer;
    registering: boolean;

constructor TDefaultPlayer.Init; begin name:='(default)'; message:=''; end;
destructor TDefaultPlayer.Done; begin end;
procedure TDefaultPlayer.InitGame(id: integer); begin end;
procedure TDefaultPlayer.Born(I_see: Tview); begin end;
procedure TDefaultPlayer.Eaten(I_saw: Tview); begin end;
procedure TDefaultPlayer.MakeMove(I_see: Tview; var command: integer); begin command:=cmdNic; end;

procedure Error(s:string);
begin
  writeln(s);
  halt(0);
end;

function IntToStr(i:longint):string;
var s:string;
begin
  Str(i,s);
  IntToStr:=s;
end;

procedure RegisterPlayer(pl:PDefaultPlayer);
begin
  if registering then exit; registering:=true;
  
  inc(reg_items);
  if reg_items>MAX_PLAYERS then Error('Cannot register more than '+IntToStr(MAX_PLAYERS)+' players!');
  reg_item[reg_items]:=pl;

  registering:=false;
end;

procedure RegisterAll(s:string);
var i:integer;
begin
  if registering then exit; registering:=true;
  
  if not vars.Invalidate(s) then Error('Cannot re-register players!');
  vars.Validate(s);
    
  for i:=1 to reg_items do
  begin
    vars.data^.pl[i].obj:=reg_item[i];
    vars.data^.pl[i].name:=reg_item[i]^.name;
    vars.data^.pl[i].score:=0;
    vars.data^.pl[i].nZrava:=0;
    vars.data^.pl[i].nZmetena:=0;
    vars.data^.pl[i].nNeviditelna:=0;
    vars.data^.pl[i].nTehlova:=0;
    vars.data^.pl[i].x:=0;
    vars.data^.pl[i].y:=0;
    vars.data^.pl[i].dir:=0;
    vars.data^.pl[i].left:=0;
  end;
  vars.data^.players:=reg_items;
  
  registering:=false;
end;
 
begin
  reg_items:=0;
  registering:=false;
  writeln('sizeof(tview) = ',sizeof(tview));
end.
