#include <stdio.h>
#include <stdlib.h>
#include "typesc.h"

int randomak(struct Tview I_see);
void takegold(struct Tview I_see, int *h, int *d, int *p, int *l);
void tyckove(struct Tview I_see, int *h, int *d, int *p, int *l);

typedef struct
{
  int x,y;
} POINT;

char iWall[MAX_PLAN_X][MAX_PLAN_Y];
int iDst[MAX_PLAN_X][MAX_PLAN_Y];
int iSaw[MAX_PLAN_X][MAX_PLAN_Y];

int d[4][2] = {{0,-1},{1,0},{0,1},{-1,0}};
POINT f[MAX_PLAN_X*MAX_PLAN_Y];
int head,tail;

int saw[5][5];
int best_val,bpath[50],nbpath;
int path_val,ppath[50],nppath;

POINT iLastMove[2];
int nLastMove;

POINT iActNavPoint;
FILE *fout;
int nTurn;

int GetVal( int sq )
{
  int v = 0;
  if ( sq & vfZlata ) v += 5;
  if ( sq & vfZrava ) v += 5;
  if ( sq & vfTehlova ) v += 1;
  if ( sq & vfTyckova ) v -= 10;
  if ( sq & vfZmetena ) v -= 15;
  if ( sq & vfOtaznik ) v -= 3;
  return v;
}


void SearchPath(int len, int x, int y, struct Tview I_see)
{
  int i,nx,ny;
  if (len == 0)
  {
    if (best_val < path_val) 
    {
      best_val = path_val;
      nbpath = nppath;
      for (i = 0; i < nppath; i++)
        bpath[i] = ppath[i];      
    }    
  }
  else
  {
    for( i = 0; i < 4; i++)
    {
      nx = x+d[i][0];
      ny = y+d[i][1];
/*      fprintf(fout,"x=%d y=%d, nx=%d ny=%d Wall=%d\n",x,y,nx,ny,I_see.view[nx][ny]&vStena);*/
      if ( nx >= 0 && nx < 5 && ny >= 0 && ny < 5 )
        if (saw[nx][ny] == 0 && (I_see.view[nx][ny] & vStena) == 0 )
	{
	  saw[nx][ny] = 1;
	  ppath[nppath++] = i;
	  path_val += GetVal( I_see.view[nx][ny] );
/*	  if ( abs(nx-x)+abs(ny-y) == 1 )
            path_val += GetVal( I_see.view[nx][ny] );
*/	  
	  SearchPath( len-1, nx,ny, I_see );

	  path_val -= GetVal( I_see.view[nx][ny] );
/*	  if ( abs(nx-x)+abs(ny-y) == 1 )
            path_val -= GetVal( I_see.view[nx][ny] );
*/
	  nppath--;	  
	  saw[nx][ny] = 0;
	}
    }    
  }
}

/* mapovanie celej mapy podla aktualneho vyhladu */
void Nav_UpdateData( struct Tview I_see )
{
  int n=2*MAX_VIEW+1, i,j, ni, nj;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
    {
      ni = I_see.x-2+i;
      nj = I_see.y-2+j;
      if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
      {
        iWall[ni][nj] = (I_see.view[i][j]&1);
        iSaw[ni][nj] = nTurn;
      }
    }
}
/* steny */
void Nav_MakeWall( struct Tview I_see, int iFlag )
{
  int n=2*MAX_VIEW+1, i,j, ni, nj;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
    {
      ni = I_see.x-2+i;
      nj = I_see.y-2+j;
      if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
        iWall[ni][nj] |= ((I_see.view[i][j]&iFlag)!=0);
    }
}

POINT Nav_QueuePop( void )
{
  return f[head++];
}
void Nav_QueuePush( POINT p, int dst )
{
  iDst[p.x][p.y] = dst;
  if ( iWall[p.x][p.y] == 0 )
  {
    f[tail].x = p.x;
    f[tail].y = p.y;
    tail++;
  }
}

/* do iDst[MaxN][MaxM] spocita vzdialenosti z iNavPoint; 
-1 - ked nie je cesta */
void Nav_SetPoint( POINT iNavPoint )
{
  int i,j,nx,ny;
  POINT p,pnew;
  
  head = tail = 0;
  for (i = 0; i < MAX_PLAN_X; i++)
    for (j = 0; j < MAX_PLAN_Y; j++)
      iDst[i][j]  = -1;
      
  f[0].x = iNavPoint.x;
  f[0].y = iNavPoint.y;
  iDst[iNavPoint.x][iNavPoint.y] = 0;
  tail++;
  while ( head < tail )
  {
    p = Nav_QueuePop();
    for (i = 0; i < 4; i++)
    {
      pnew.x = p.x+d[i][0];
      pnew.y = p.y+d[i][1];
      if ( pnew.x >= 0 && pnew.y < MAX_PLAN_X && pnew.y >= 0 && pnew.y < MAX_PLAN_Y )
        if ( iDst[pnew.x][pnew.y] < 0 )
          Nav_QueuePush( pnew, iDst[p.x][p.y]+1 );  
    }    
  } 
}

/* najde miesto, kam podjeme */
POINT Nav_FindPoint( struct Tview I_see )
{
  POINT iPoint; 
  int i,j,found=0;
  
  iPoint.x = I_see.x;
  iPoint.y = I_see.y;
  
  Nav_SetPoint( iPoint );
  for (i = 0; i < MAX_PLAN_X; i++)
    for (j = 0; j < MAX_PLAN_Y; j++)
      if (( iWall[i][j] == 0 || iSaw[i][j] < 0 ) && ( iDst[i][j] > 0 )) 
      {
        if (found == 0)
	{ iPoint.x=i;iPoint.y=j; found=1;}
	else
	  if ( iSaw[ iPoint.x ][ iPoint.y ] > iSaw[ i ][ j ] )
	  { iPoint.x=i; iPoint.y=j; }
	  else
	  if ( iSaw[ iPoint.x ][ iPoint.y ] == iSaw[ i ][ j ] )
	    if ( iDst[ iPoint.x ][ iPoint.y ] > iDst[ i ][ j ] )
            { iPoint.x=i; iPoint.y=j; }
      }
  iActNavPoint.x = iPoint.x;
  iActNavPoint.y = iPoint.y;
  return iPoint;  
}
void DebugMove(int dir)
{
  switch(dir)
  {
    case cmdChodHore: fprintf(fout,"chod hore\n");
    return ;
    case cmdChodDole: fprintf(fout,"chod dole\n");
    return ;
    case cmdChodVpravo: fprintf(fout,"chod vpravo\n");
    return ;
    case cmdChodVlavo: fprintf(fout,"chod vlavo\n");
    return ;
    default: fprintf(fout,"Neznamy: %d\n",dir);
  }
}
/* kam tahat, aby sme co najrychlejsie prisli do ciela */
int Nav_GetNextMove( struct Tview I_see, int *moveVal )
{
  int n=2*MAX_VIEW+1,i,j,ni,nj, mini,minj,minv=-1, dir;
  for ( i = 0; i < 4; i++ )
  {
    ni = I_see.x+d[i][0];
    nj = I_see.y+d[i][1];
    if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
    if ( iWall[ni][nj] == 0 && iDst[ni][nj] > 0 )
    {
      if (minv == -1 || ( minv > iDst[ni][nj] ) )
      {
        dir = i;
        minv = iDst[ni][nj];
        mini = ni; minj = nj;
      }
    }
  }
  *moveVal = minv;
  if (minv == -1)
    return 0;
  switch(dir)
  {
    case 0: fprintf(fout,"chod hore\n");
    return cmdChodHore;
    case 1: fprintf(fout,"chod vpravo\n");
    return cmdChodVpravo;
    case 2: fprintf(fout,"chod dole\n");
    return cmdChodDole;
    case 3: fprintf(fout,"chod vlavo\n");
    return cmdChodVlavo;
  }
  
}


	
void cplayer_InitGame(int id)
{
  int i,j;

  fout = fopen("proboj.log.tmp","wt");
  
  nTurn = 0;
  for (i = 0; i < MAX_PLAN_X; i++)
    for (j = 0; j < MAX_PLAN_Y; j++)
    {
      iSaw[i][j] = -999999999;
      iWall[i][j] = 1;
    }
}

void cplayer_Born(struct Tview I_see)
{
  FILE *f;
  int i,j;
  
  // code here...
/*
  f=fopen("c4.log","w");
  fprintf(f,"Born at %d,%d\n",I_see.x,I_see.y);
  for (j=0;j<5;j++)
  {
    for (i=0;i<5;i++) fprintf(f,"%8X ",I_see.view[i][j]);
    fprintf(f,"\n");
  }
  fclose(f);
*/
}

void cplayer_Eaten(struct Tview I_saw)
{
  
}

int cplayer_MakeMove(struct Tview I_see)
{
        int move,i,j,k,val,best=-1, dir;
	int moveVal;
	POINT iPoint;
/*	int l=0, p=0, h=0, d=0;
	int move;
  	FILE *f;
*/
        nTurn++;
	Nav_UpdateData( I_see );

        best = -999;
        fprintf(fout,"\nTah %d: [%d,%d]\n",nTurn,iActNavPoint.x,iActNavPoint.y);
	/* prehladavaj cesty dlzky i=1...3 */
	for (i = 1; i <= 3; i++)
  	{
	  for (j = 0; j < 5; j++)
	  for (k = 0; k < 5; k++)
	    saw[j][k] = 0;	    
          best_val = -99999;
	  nbpath = 0;
	  nppath = 0;
	  path_val = 0;
	  
	  SearchPath( i, 2,2, I_see );
          if ( best < best_val )
	  {
	    best = best_val;
	    dir = bpath[0];
	  }
	  fprintf(fout,"dlzka=%d, cena=%d\n",i,best_val);
//	  fprintf(fout,"best=%3d, best_val=%3d, kam=%d\n",best,best_val,dir);
	}
        if ( best >= 3 )
	{
	  // lokalna
	  DebugMove(dir);
	  switch(dir)
          {
          case 0: fprintf(fout,"chod hore\n");
          return cmdChodHore;
          case 1: fprintf(fout,"chod vpravo\n");
          return cmdChodVpravo;
          case 2: fprintf(fout,"chod dole\n");
          return cmdChodDole;
	  case 3: fprintf(fout,"chod vlavo\n");
	  return cmdChodVlavo;
	  }
        }
	else
	{
	  // globalna
          for (i = 0; i < MAX_PLAN_X; i++)
          {
             for (j = 0; j < MAX_PLAN_Y; j++)
               fprintf(fout,"%d",iWall[j][i]);
             fprintf(fout,"\n");
          }

	  iPoint = Nav_FindPoint( I_see );
	  
          /* ignoruj zmetenu,tyckovu,otaznik */	  
	  Nav_MakeWall( I_see, vfZmetena );
	  Nav_MakeWall( I_see, vfTyckova );
	  Nav_MakeWall( I_see, vfOtaznik );

	  fprintf(fout,"------------------------------\n");
          for (i = 0; i < MAX_PLAN_X; i++)
          {
             for (j = 0; j < MAX_PLAN_Y; j++)
               fprintf(fout,"%d",iWall[j][i]);
             fprintf(fout,"\n");
          }

          for (i = 0; i < MAX_PLAN_X; i++)
          {
             for (j = 0; j < MAX_PLAN_Y; j++)
               fprintf(fout,"%2d ",iDst[j][i]);
             fprintf(fout,"\n");
          }
	  Nav_SetPoint( iPoint );
	  fprintf(fout,"------------------------------\n");
          for (i = 0; i < MAX_PLAN_X; i++)
          {
             for (j = 0; j < MAX_PLAN_Y; j++)
               fprintf(fout,"%2d ",iDst[j][i]);
             fprintf(fout,"\n");
          }
	
          move = Nav_GetNextMove( I_see, &moveVal );
	  fprintf(fout,"ignoruj A(%d)\n",moveVal);
	  DebugMove(move);
	  if (move)
	    return move;
	  /* resetni spravne steny */
	  Nav_UpdateData( I_see );

          /* ignoruj zmetenu,tyckovu */	  
	  Nav_MakeWall( I_see, vfZmetena );
	  Nav_MakeWall( I_see, vfTyckova );
	    
	  Nav_SetPoint( iPoint );
	
          move = Nav_GetNextMove( I_see, &moveVal );
	  fprintf(fout,"ignoruj B(%d)\n",moveVal);
	  DebugMove(move);
	  if (move)
	      return move;
	  /* resetni spravne steny */
	  Nav_UpdateData( I_see );

          /* ignoruj zmetenu */	  
	  Nav_MakeWall( I_see, vfZmetena );
	    
	  Nav_SetPoint( iPoint );
	
          move = Nav_GetNextMove( I_see, &moveVal );
	  fprintf(fout,"ignoruj C(%d)\n",moveVal);
	  DebugMove(move);
	  if (move)
            return move;
	  /* resetni spravne steny */
	  Nav_UpdateData( I_see );

	  Nav_SetPoint( iPoint );
	
          move = Nav_GetNextMove( I_see, &moveVal );
	  fprintf(fout,"neignoruj(%d)\n",moveVal);
	  DebugMove(move);
	  if (move)
	    return move;
	  /* nemame kam tahat - sme zamurovany? */
	}
	
	//	Tu zacinaju funkcie	
	
	//takegold(I_see, &h, &d, &p, &l);
	//tyckove(I_see, &h, &d, &p, &l);
	
	
/*	
	move = Nav_GetNextMove( I_see );
	
	///////////////
	if ( I_see.view[2+1][2] & vfZlata )
	  return cmdChodVpravo;
	if ( I_see.view[2-1][2] & vfZlata )
	  return cmdChodVlavo;
	if ( I_see.view[2][2+1] & vfZlata )
	  return cmdChodDole;
	if ( I_see.view[2][2-1] & vfZlata )
	  return cmdChodHore;
	return move;
	///////////////
	
	if(move == 1) { h += 20; }
	else if(move == 2) { p += 20; }
	else if(move == 3) { d += 20; }
	else if(move == 4) { l += 20; }
	
	//	Vyhodnocovanie	
	
	if(h > p && h > l && h > d) { 
		if(I_see.view[2][1] != vStena) {
			return 1; 
		}
	}
	if(p > l && p > h && p > d) { 
		if(I_see.view[3][2] != vStena) {
			return 2;
		}
	}
	if(d > p && d > l && d > h) { 
		if(I_see.view[2][3] != vStena) {
			return 3;	
		}
	}
	if(l > p && l > h && l > d) { 
		if(I_see.view[1][2] != vStena) {
			return 4;
		}
	}
*/	return 0;
}

	
int randomak(struct Tview I_see)
{
	int move;

	while(1) {
		move = rand()%4+1;
		if(move == 1 && (I_see.view[2][1] != vStena)) {
			return 1;
		}
		if(move == 2 && (I_see.view[3][2] != vStena)) {
			return 2;
		}
		if(move == 3 && (I_see.view[2][3] != vStena)) {
			return 3;
		}
		if(move == 4 && (I_see.view[1][2] != vStena)) {
			return 4;
		}
	}
}

void takegold(struct Tview I_see, int *h, int *d, int *p, int *l)
{
	int i, j;
	int a[5][5] = {10,15,21,15,10,
		       15,21,30,21,15,
		       21,30,45,30,21,
		       15,21,30,21,15,
		       10,15,21,15,10};

	for(i = 0; i < 5; i++) {
		for(j = 0; j < 5; j++) {
			if(I_see.view[i][j] == vfZlata) {
				if((j == 0 && i < 4) || (j == 1 && i < 3 && i > 0)) {
					*h += a[i][j];
				} else if((j == 3 && i < 4 && i > 1) || (j == 4 && i > 0)) {
					*d += a[i][j];
				} else if((i == 3 && j < 3 && j > 0) || (i == 4 && j < 4)) {
					*p += a[i][j];
				} else if((i == 1 && j < 4 && j > 1) || (i == 0 && j > 0)) {
					*l += a[i][j];
				}
			}
		}
	}
}

void tyckove(struct Tview I_see, int *h, int *d, int *p, int *l)
{
	int i, j;
	int a[5][5] = {0,0,0,0,0,0,0,-10,0,0,0,-10,0,-10,0,0,0,-10,0,0,0,0,0,0,0};

	for(i = 0; i < 5; i++) {
		for(j = 0; j < 5; j++) {
			if(I_see.view[i][j] == vfTyckova) {
				if((j == 0 && i < 4) || (j == 1 && i < 3 && i > 0)) {
					*h += a[i][j];
				} else if((j == 3 && i < 4 && i > 1) || (j == 4 && i > 0)) {
					*d += a[i][j];
				} else if((i == 3 && j < 3 && j > 0) || (i == 4 && j < 4)) {
					*p += a[i][j];
				} else if((i == 1 && j < 4 && j > 1) || (i == 0 && j > 0)) {
					*l += a[i][j];
				}
			}
		}
	}
}
