/* Latky, Polianky, 2002, Bystrohlav */
#include <stdio.h>
#include <stdlib.h>
#include "typesc.h"

typedef struct
{
  int x,y;
} POINT;

char iWall[MAX_PLAN_X][MAX_PLAN_Y];
int iDst[MAX_PLAN_X][MAX_PLAN_Y];
int iSaw[MAX_PLAN_X][MAX_PLAN_Y];

int d[4][2] = {{0,-1},{1,0},{0,1},{-1,0}};
POINT f[MAX_PLAN_X*MAX_PLAN_Y];
int head,tail;

int saw[5][5];
int best_val,bpath[50],nbpath;
int path_val,ppath[50],nppath;

POINT iForbiddenMove[10];
int nForbiddenMove;

int isBricking,brickingDir;

POINT iActNavPoint;
//FILE *fout;
int nTurn;

void AddForbidden( int x,int y )
{
  if (nForbiddenMove >= 10)
    return;
  iForbiddenMove[nForbiddenMove].x = x;
  iForbiddenMove[nForbiddenMove].y = y;
  nForbiddenMove++;
}

int Forbidden( int x, int y )
{
  int i;
  for (i = 0; i < nForbiddenMove; i++)
    if (iForbiddenMove[i].x == x && iForbiddenMove[i].y == y)
      return 1;
  return 0;
}

int GetVal( int sq )
{
  int v = 0;
  if ( sq & vfZlata ) v += 5;
  if ( sq & vfZrava ) v += 5;
  if ( sq & vfNeviditelna ) v += 2;
  if ( sq & vfTehlova ) v += 2;
  if ( sq & vfTyckova ) v -= 10;
  if ( sq & vfZmetena ) v -= 15;
  if ( sq & vfOtaznik ) v -= 3;
  return v;
}


void SearchPath(int len, int x, int y, struct Tview I_see)
{
  int i,nx,ny;
  if (len == 0)
  {
    if (best_val < path_val) 
    {
      best_val = path_val;
      nbpath = nppath;
      for (i = 0; i < nppath; i++)
        bpath[i] = ppath[i];      
    }    
  }
  else
  {
    for( i = 0; i < 4; i++)
    {
      nx = x+d[i][0];
      ny = y+d[i][1];
      if ( nx >= 0 && nx < 5 && ny >= 0 && ny < 5 )
        if (saw[nx][ny] == 0 && (I_see.view[nx][ny] & vStena) == 0 )
	{
	  saw[nx][ny] = 1;
	  ppath[nppath++] = i;
	  
	  path_val += GetVal( I_see.view[nx][ny] );
/*	  if ( abs(nx-x)+abs(ny-y) == 1 )
          path_val += GetVal( I_see.view[nx][ny] );
*/	 	  
	  SearchPath( len-1, nx,ny, I_see );

	  path_val -= GetVal( I_see.view[nx][ny] );
/*	  if ( abs(nx-x)+abs(ny-y) == 1 )
            path_val -= GetVal( I_see.view[nx][ny] );
*/
	  nppath--;	  
	  saw[nx][ny] = 0;
	}
    }    
  }
}

/* mapovanie celej mapy podla aktualneho vyhladu */
void Nav_UpdateData( struct Tview I_see )
{
  int n=2*MAX_VIEW+1, i,j, ni, nj;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
    {
      ni = I_see.x-2+i;
      nj = I_see.y-2+j;
      if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
      {
        iWall[ni][nj] = (I_see.view[i][j]&1);
        iSaw[ni][nj] = nTurn;
      }
    }
}
/* steny */
void Nav_MakeWall( struct Tview I_see, int iFlag )
{
  int n=2*MAX_VIEW+1, i,j, ni, nj;
  for (i = 0; i < n; i++)
    for (j = 0; j < n; j++)
    {
      ni = I_see.x-2+i;
      nj = I_see.y-2+j;
      if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
        iWall[ni][nj] |= ((I_see.view[i][j]&iFlag)!=0);
    }
}

POINT Nav_QueuePop( void )
{
  return f[head++];
}
void Nav_QueuePush( POINT p, int dst )
{
  iDst[p.x][p.y] = dst;
  if ( iWall[p.x][p.y] == 0 )
  {
    f[tail].x = p.x;
    f[tail].y = p.y;
    tail++;
  }
}

/* do iDst[MaxN][MaxM] spocita vzdialenosti z iNavPoint; 
-1 - ked nie je cesta */
void Nav_SetPoint( POINT iNavPoint )
{
  int i,j,nx,ny;
  POINT p,pnew;
  
  head = tail = 0;
  for (i = 0; i < MAX_PLAN_X; i++)
    for (j = 0; j < MAX_PLAN_Y; j++)
      iDst[i][j]  = -1;
      
  f[0].x = iNavPoint.x;
  f[0].y = iNavPoint.y;
  iDst[iNavPoint.x][iNavPoint.y] = 0;
  tail++;
  while ( head < tail )
  {
    p = Nav_QueuePop();
    for (i = 0; i < 4; i++)
    {
      pnew.x = p.x+d[i][0];
      pnew.y = p.y+d[i][1];
      if ( pnew.x >= 0 && pnew.y < MAX_PLAN_X && pnew.y >= 0 && pnew.y < MAX_PLAN_Y )
        if ( iDst[pnew.x][pnew.y] < 0 )
          Nav_QueuePush( pnew, iDst[p.x][p.y]+1 );  
    }    
  } 
}

/* najde miesto, kam podjeme */
POINT Nav_FindPoint( struct Tview I_see )
{
  POINT iPoint; 
  int i,j,found=0;
  
  iPoint.x = I_see.x;
  iPoint.y = I_see.y;
  
  Nav_SetPoint( iPoint );
  for (i = 0; i < MAX_PLAN_X; i++)
    for (j = 0; j < MAX_PLAN_Y; j++)
      if (( iWall[i][j] == 0 || iSaw[i][j] < 0 ) && ( iDst[i][j] > 0 )) 
      {
        if (found == 0)
	{ iPoint.x=i;iPoint.y=j; found=1;}
	else
	  if ( iSaw[ iPoint.x ][ iPoint.y ] > iSaw[ i ][ j ] )
	  { iPoint.x=i; iPoint.y=j; }
	  else
	  if ( iSaw[ iPoint.x ][ iPoint.y ] == iSaw[ i ][ j ] )
	    if ( iDst[ iPoint.x ][ iPoint.y ] > iDst[ i ][ j ] )
            { iPoint.x=i; iPoint.y=j; }
      }
  iActNavPoint.x = iPoint.x;
  iActNavPoint.y = iPoint.y;
  return iPoint;  
}

/* kam tahat, aby sme co najrychlejsie prisli do ciela */
int Nav_GetNextMove( struct Tview I_see, int *moveVal )
{
  int n=2*MAX_VIEW+1,i,j,ni,nj, mini,minj,minv=-1, dir;
  for ( i = 0; i < 4; i++ )
  {
    ni = I_see.x+d[i][0];
    nj = I_see.y+d[i][1];
    if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
    if ( iWall[ni][nj] == 0 && iDst[ni][nj] > 0 && Forbidden( ni,nj) == 0 )
    {
      if (minv == -1 || ( minv > iDst[ni][nj] ) )
      {
        dir = i;
        minv = iDst[ni][nj];
        mini = ni; minj = nj;
      }
    }
  }
  *moveVal = minv;
  if (minv == -1)
    return 0;
  switch(dir)
  {
    case 0: /*fprintf(fout,"chod hore\n");*/
    return cmdChodHore;
    case 1: /*fprintf(fout,"chod vpravo\n");*/
    return cmdChodVpravo;
    case 2: /*fprintf(fout,"chod dole\n");*/
    return cmdChodDole;
    case 3: /*fprintf(fout,"chod vlavo\n");*/
    return cmdChodVlavo;
  }  
}
int Transform( int move )
{
  switch(move)
  {
    case cmdChodHore: return 0;
    case cmdChodVpravo: return 1;
    case cmdChodDole: return 2;
    case cmdChodVlavo: return 3;
  }
  return 0;
}

int DoBrick( int sq )
{
  if (sq & vfZmetena ) return 1;
  if (sq & vfTyckova ) return 1;
  if (sq & vfOtaznik ) return 1;
    
  return 0;
}
	
void cplayer_InitGame(int id)
{
  int i,j;

//  fout = fopen("proboj.log.tmp","wt");
  nTurn = 0;
  for (i = 0; i < MAX_PLAN_X; i++)
    for (j = 0; j < MAX_PLAN_Y; j++)
    {
      iSaw[i][j] = -999999999;
      iWall[i][j] = 1;
    }
}

void cplayer_Born(struct Tview I_see)
{
  // sorry, no code here...:(
}

void cplayer_Eaten(struct Tview I_saw)
{
  // sorry, no code here...:(
}

int cplayer_MakeMove(struct Tview I_see)
{
        int move=0,i,j,k,val,best=-1, dir,ni,nj;
	int moveVal,tmp;
	POINT iPoint;

        nTurn++;
	Nav_UpdateData( I_see );
	
	/* tehlovanie zlych guliciek */
	if ( isBricking )
	{
	  isBricking = 0;
	  return brickingDir;
	}
	
	/* slimaky */
	if ( I_see.nZrava == 0 )
          for ( i = 0; i < 4; i++ )
          {
            ni = I_see.x+d[i][0];
            nj = I_see.y+d[i][1];
            if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
              if ( I_see.view[2+d[i][0]][2+d[i][1]] & vSlimak )
  	        AddForbidden( ni, nj );
          }	 
	/* vyslobodenie sa zo zovretia stien */
	if ( I_see.nTehlova )
        {
	  for ( k = 0, i = 0; i < 4; i++ )
          {
            ni = I_see.x+d[i][0];
            nj = I_see.y+d[i][1];
            if ( ni >= 0 && nj >= 0 && ni < MAX_PLAN_X && nj < MAX_PLAN_Y)
              k += iWall[ni][nj];
          }	 
	  if (k == 4)
	    return 5+rand()%4;
	}	

        best = -999;
//        fprintf(fout,"\nTah %d: [%d,%d]\n",nTurn,iActNavPoint.x,iActNavPoint.y);
	/* prehladavaj cesty dlzky i=1...3 */
	for (i = 1; i <= 3; i++)
  	{
	  for (j = 0; j < 5; j++)
	  for (k = 0; k < 5; k++)
	    saw[j][k] = 0;	    
          best_val = -99999;
	  nbpath = 0;
	  nppath = 0;
	  path_val = 0;
	  
	  SearchPath( i, 2,2, I_see );
	  tmp = bpath[0];
          if ( best < best_val && Forbidden( I_see.x+d[tmp][0], I_see.y+d[tmp][1] ) == 0 )
	  {
	    best = best_val;
	    dir = tmp;
	  }
//	  fprintf(fout,"dlzka=%d, cena=%d\n",i,best_val);
	}
        if ( best >= 3 )
	{
	  // lokalna
	  switch(dir)
          {
          case 0: /*fprintf(fout,"chod hore\n");*/
	  nForbiddenMove = 0; if (rand()%3==0) AddForbidden( I_see.x, I_see.y-1 );
          return cmdChodHore;
          case 1: /*fprintf(fout,"chod vpravo\n");*/
	  nForbiddenMove = 0; if (rand()%3==0) AddForbidden( I_see.x+1, I_see.y );
          return cmdChodVpravo;
          case 2: /*fprintf(fout,"chod dole\n");*/
	  nForbiddenMove = 0; if (rand()%3==0) AddForbidden( I_see.x, I_see.y+1 );
          return cmdChodDole;
	  case 3: /*fprintf(fout,"chod vlavo\n");*/
	  nForbiddenMove = 0; if (rand()%3==0) AddForbidden( I_see.x-1, I_see.y );
	  return cmdChodVlavo;
	  }
        }
	else
	{
	  // globalna
/*          for (i = 0; i < MAX_PLAN_X; i++)
          {
             for (j = 0; j < MAX_PLAN_Y; j++)
               fprintf(fout,"%d",iWall[j][i]);
             fprintf(fout,"\n");
          }
*/
	  iPoint = Nav_FindPoint( I_see );
	  
          /* ignoruj zmetenu,tyckovu,otaznik */	  
	  Nav_MakeWall( I_see, vfZmetena );
	  Nav_MakeWall( I_see, vfTyckova );
	  Nav_MakeWall( I_see, vfOtaznik );

          Nav_SetPoint( iPoint );
	  
          move = Nav_GetNextMove( I_see, &moveVal );
//	  fprintf(fout,"ignoruj A(%d)\n",moveVal);
	  nForbiddenMove = 0; 
          if (rand()%3==0) AddForbidden( I_see.x+d[move][0], I_see.y+d[move][1] );
	  if (move>0)
	  {
	    tmp = Transform(move);
	    if ( I_see.nTehlova >= 2 && DoBrick( I_see.view[2+d[tmp][0]][2+d[tmp][1]] ) )
	    {  isBricking = 1;
	       brickingDir = move+4;
	       return brickingDir;
	    }
	    return move;
	  }
	  /* resetni spravne steny */
	  Nav_UpdateData( I_see );

          /* ignoruj zmetenu,tyckovu */	  
	  Nav_MakeWall( I_see, vfZmetena );
	  Nav_MakeWall( I_see, vfTyckova );
	    
	  Nav_SetPoint( iPoint );
	
          move = Nav_GetNextMove( I_see, &moveVal );
//	  fprintf(fout,"ignoruj B(%d)\n",moveVal);
	  nForbiddenMove = 0; 
	  if (rand()%3==0) AddForbidden( I_see.x+d[move][0], I_see.y+d[move][1] );
	  if (move>0)
	  {
	    tmp = Transform(move);
	    if ( I_see.nTehlova >= 2 && DoBrick( I_see.view[2+d[tmp][0]][2+d[tmp][1]] ) )
	    {  isBricking = 1;
	       brickingDir = move+4;
	       return brickingDir;
	    }
	    return move;
	  }

	  /* resetni spravne steny */
	  Nav_UpdateData( I_see );

          /* ignoruj zmetenu */	  
	  Nav_MakeWall( I_see, vfZmetena );
	    
	  Nav_SetPoint( iPoint );
	
          move = Nav_GetNextMove( I_see, &moveVal );
//	  fprintf(fout,"ignoruj C(%d)\n",moveVal);
	  nForbiddenMove = 0; 
	  if (rand()%3==0) AddForbidden( I_see.x+d[move][0], I_see.y+d[move][1] );
	  if (move>0)
	  {
	    tmp = Transform(move);
	    if ( I_see.nTehlova >= 2 && DoBrick( I_see.view[2+d[tmp][0]][2+d[tmp][1]] ) )
	    {  isBricking = 1;
	       brickingDir = move+4;
	       return brickingDir;
	    }
	    return move;
	  }
	  /* resetni spravne steny */
	  Nav_UpdateData( I_see );

	  Nav_SetPoint( iPoint );
	
          move = Nav_GetNextMove( I_see, &moveVal );
//	  fprintf(fout,"neignoruj(%d)\n",moveVal);
	  nForbiddenMove = 0; 
	  if (rand()%3==0) AddForbidden( I_see.x+d[move][0], I_see.y+d[move][1] );
	  if (move>0)
	  {
	    tmp = Transform(move);
	    if ( I_see.nTehlova >= 2 && DoBrick( I_see.view[2+d[tmp][0]][2+d[tmp][1]] ) )
	    {  isBricking = 1;
	       brickingDir = move+4;
	       return brickingDir;
	    }
	    return move;
	  }

	  /* nemame kam tahat - sme zamurovany? */
	  
	}
        return 0;	
}