unit display;
interface
uses types,
     graph,

     sysutils, ports,
{$IFDEF sound} esdpp, {$ENDIF}

     crt;
     







type Tpal = array[0..1023] of byte;

type Tmsgs=record
             size: integer;
	     count: integer;
	     item: array[1..100] of record
	                              s: string;
			 	      col: integer;
			 	      inv: boolean;
				      xpos: integer; 
				      wid: integer;
				    end;
	   end;



     Timage = array[0..640*480-1] of byte;
     Pimage = ^Timage;
     
     Timg = record
    	      width,height,cols,offs: longint;
	      trans: integer;
	      data: Pimage;
	      pal: Pimage;
    	    end;
     Pimg = ^Timg;


const
  BackCol = 0;

const

  PlayerCols:array[0..MAX_PLAYERS] of byte=
        ( lightgray, red, green, blue, yellow, white, white, white, white ); 

  FoodCols:array[1..7] of byte = (yellow, lightblue, lightgreen, lightred, lightcyan, lightgray, white);

  PlayerColsS:array[1..MAX_PLAYERS] of string=
        ('red', 'green', 'blue', 'yellow', 'white', 'white', 'white', 'white'); 
  PlayerPal:array[1..MAX_PLAYERS] of integer = (21,26,31,36,41,41,41,41);


const first:boolean = true;
      SPEED_VERT  = 6;
      SPEED_HORIZ = 8;
      need_cls: boolean = false;
      
      BACKIMG_name = 'pcx/background.pcx';
      FONTIMG_name = 'pcx/inoutro/font_x.pcx';
      FONT_yskip   = 1;
      INTROIMG_name = 'pcx/intro.pcx';
      RESULTSIMG_name = 'pcx/results.pcx';
      
      MSGS_SPEED   = 5;
      
      SIZE_X = 16;
      SIZE_Y = 16;
      
      global_mode: integer = 0;

type Tfont = record
               rows: integer;
               row:array[1..10] of record
                          top, bot: integer;
			  base, wid: integer;
			  cols: integer;
			  col: array[1..20] of record
			                         left, right: integer;
					       end;	 
                        end; 
               chars: array[#0..#255] of record row,col: integer; end;
	       maxdepth: integer;
	       img: Timg;
	     end;  

const chartab = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789 !-():;,./?''"=+_';
  
 
const res_delay: array[1..4] of longint = (9200,3000,2000,2000);

var
    actions: integer;
    action: array[1..1000] of record
	      cmd: integer;
	      x,y: integer;
	    end;



var pal: Tpal;

function IntToStr(i:longint):string;
function RealToStr(r:real; i,j:integer): string;

procedure disp_Init;
procedure disp_Done;

procedure BeforeGame;
procedure AfterGame;

procedure ClearScreen;
procedure ClearStatus;

function kdelay(t:longint):boolean;
function kdelay2(t:longint):boolean;

procedure ShowPlan(data:Pdata; fast:boolean);
procedure ShowData(data:Pdata; pl:integer);
procedure ShowView(view:Tview; dy:integer);

{
procedure SetMsg(var msgs:Tmsgs);
procedure ShowMsgs(var msgs:Tmsgs);
procedure ShowField(pl1,pl2: integer);
procedure ShowHit(pl: integer);
procedure ShowData(i: integer; pl: integer; left: integer);
procedure ShowWinner(pl1,pl2: integer; sc1,sc2: longint);

procedure ShowPlayer(dir: integer; p:real; lst, nst:integer; pst:real; pl:integer);
procedure HidePlayer(dir: integer; p:real; lst, nst:integer; pst:real; pl:integer);

procedure LogMove(rnd: longint; i, ns: integer; dpos: real; go: integer);
}


procedure LoadImages;

procedure ShowIntro;
procedure ShowOutro;
procedure ShowGameNo(game_no: integer);
procedure ShowActions(data:Pdata);
procedure ShowData(data:Pdata; pl:integer; fast:boolean);
procedure ShowResults;

procedure PrintPCXText(x,y: integer; s:string; fnt:Tfont);
procedure PrintPCXText(x,y: integer; s:string; fnt:Tfont; o:integer; inv: boolean);
procedure PrintPCXText2(x,y: integer; s:string; fnt:Tfont; o:integer; inv: boolean);
function PCXTextWidth(s:string; fnt:Tfont): integer;
procedure ParsePCXfont(img: Timg; y_skip: integer; var fnt: Tfont);

procedure IQ_start;
procedure IQ_finish;
procedure IQ_pixel(x,y,col: integer);
procedure IQ_line(x0,y0,x1,y1, col: integer);

procedure DrawColor(c:integer);
procedure CrossColor(c:integer);
procedure CrossBMP(s:string; o:integer);
procedure LoadPCX(s:string; cols,o: integer; var img:Timg; trans:integer; setpal:boolean);
procedure CrossPCX(img:Timg; cols,o:integer);
procedure CrossPCX(s:string; cols,o:integer);
procedure DrawPCX(s:string; dx,dy,cols,o,trans:integer);
procedure DrawPCX_IQ(s:string; dx,dy,cols,o,trans:integer);
procedure DrawBMP(s:string; ww,hh,dx,dy,o,trans:integer);

procedure DrawIMG(img:Timg; dx,dy:integer; palshift:integer);
procedure DrawIMG(img:Timg; dx,dy:integer);
procedure HideIMG(img:Timg; dx,dy:integer);



implementation
uses vars;
var erase: boolean;
    font: Tfont;
    xoff, yoff: integer;
    
    IQ_active: boolean;


type PCXheader = packed record
                      Identifier:byte;
                      Version:byte;
                      Encoding:byte;
                      BitsPerPixel:byte;
                      XStart:word;
                      YStart:word;
                      XEnd:word;
                      YEnd:word;
                      HorzRes:word;
                      VertRes:word;
                      Palette:array[0..47] of byte;
                      Reserved1:byte;
                      NumBitPlanes:byte;
                      BytesPerLine:word;
                      PaletteType:word;
                      HorzScreenSize:word;
                      VertScreenSize:word;
                      Reserved2:array[0..53] of byte;
                 end;

type Piq = ^Tiq;
     Tiq = packed record
             x,y: integer;
	     col: byte;
           end;
	   
     Pcmpfunction = ^Tcmpfunction;
     Tcmpfunction = function(a,b: pointer): integer;

	   
var backimg, introimg, resultsimg, fontimg: Timg;
    
    imgStena, imgHeart, imgDummy: Timg;
    imgfZlata, imgfZrava, imgfTehlova, imgfZmetena, imgfNeviditelna, 
    imgfTyckova, imgfOtaznik: Timg;
    imgStatusZrava, imgStatusTehlova, imgStatusNeviditelna, imgStatusZmetena: Timg;

    imgPl: array[1..MAX_PLAYERS,0..3] of Timg;

    IQ_list: array[0..300000] of Tiq;
    i,IQ_count: longint;

    { try 2 }
    IQ_img: Timage;
    IQ_minx, IQ_maxx, IQ_miny, IQ_maxy: integer;

    old_score: array[1..MAX_PLAYERS] of record
                 score: longint;
		 nzrava, nzmetena, nneviditelna, ntehlova: integer;
	       end;	 

const rn: integer = 0;
      msgs_o: integer = 0;
    


function max(a,b:longint): longint;
begin
  if a>b then max:=a else max:=b;
end;

function min(a,b:longint): longint;
begin
  if a<b then min:=a else min:=b;
end;

{$IFDEF FPC}
function max(a,b:real): real;
begin
  if a>b then max:=a else max:=b;
end;
{$ENDIF}

function IntToStr(i:longint):string;
var s:string;
begin
  Str(i,s);
  IntToStr:=s;
end;

function RealToStr(r:real; i,j:integer): string;
var s:string;
begin
  str(r:i:j,s);
  RealToStr:=s;
end;

var Gd,Gm:integer;

procedure SetRGB(c,r,g,b:byte);
begin
  Port[$3c8]:=c; 
  Port[$3c9]:=r shr 2; 
  Port[$3c9]:=g shr 2; 
  Port[$3c9]:=b shr 2; 
end;

procedure SetPalette(pal:Tpal);
var i:integer;
begin
  for i:=0 to 255 do SetRGB(i,Pal[i*4+2],Pal[i*4+1],Pal[i*4]);
end;

procedure SetPalettePartial(pal:Tpal; count,offset:integer);
var i:integer;
begin
  for i:=0 to count-1 do 
    SetRGB(offset+i,Pal[i*4+2],Pal[i*4+1],Pal[i*4]);
end;

procedure disp_Init;
var i:integer;
begin
{$IFDEF LINUX}
  gd:=d8bit; 
  gm:=m640x480;
{$ELSE}
  gd:=detect;
{$ENDIF}  
  InitGraph(gd,gm,'');

  xoff:=((GetMaxX+1)-MAX_PLAN_X*SIZE_X) div 2;
  yoff:=((GetMaxY+1)-MAX_PLAN_Y*SIZE_Y) div 2;


{  SetPalette;  }
  SetRGB(green,0,150,0); 
  SetRGB(blue,50,50,240);  { trochu svetlejsia modra }

  { problemy s farbou ciernej: kym sa nezavola outtextxy, tak cierna je biela }
  { nech ziju bugy v graph a/alebo svgalib :-)) }
  outtextxy(0,0,'.');
  setfillstyle(1,0);
  bar(0,0,8,8);
end;


procedure LoadImages;
var i:integer;
begin
  { load backimgs }
  { 201-249 }
  LoadPCX(BACKIMG_name,49,201,backimg,-1,false);
 
  LoadPCX(RESULTSIMG_name,200,50,resultsimg,-1,false);

  { load font }
  LoadPCX(FONTIMG_name,5,250,fontimg,-1,true);
  ParsePCXfont(fontimg,font_yskip,font);
  
  { load field images }
  LoadPCX('pcx/stena.pcx',5,16,imgStena,-1,true);
  LoadPCX('pcx/heart.pcx',5,21,imgHeart,0,false);
  LoadPCX('pcx/fazulka_zlata.pcx',5,46,imgfZlata,0,true);
  LoadPCX('pcx/fazulka_zrava.pcx',5,51,imgfZrava,0,true);
  LoadPCX('pcx/fazulka_tehlova.pcx',5,56,imgfTehlova,0,true);
  LoadPCX('pcx/fazulka_zmetena.pcx',5,61,imgfZmetena,0,true);
  LoadPCX('pcx/fazulka_neviditelna.pcx',5,66,imgfNeviditelna,0,true);
  LoadPCX('pcx/fazulka_tyckova.pcx',5,71,imgfTyckova,0,true);
  LoadPCX('pcx/fazulka_otaznik.pcx',5,76,imgfOtaznik,0,true);
    
  for i:=1 to MAX_PLAYERS do
  begin
    LoadPCX('pcx/panacik_'+PlayerColsS[i]+'_up.pcx',5,16+5*min(i,5),imgPl[i,0],0,true);
    LoadPCX('pcx/panacik_'+PlayerColsS[i]+'_right.pcx',5,16+5*min(i,5),imgPl[i,1],0,true);
    LoadPCX('pcx/panacik_'+PlayerColsS[i]+'_down.pcx',5,16+5*min(i,5),imgPl[i,2],0,true);
    LoadPCX('pcx/panacik_'+PlayerColsS[i]+'_left.pcx',5,16+5*min(i,5),imgPl[i,3],0,true);
  end;

  { 81-100: farby pre texty }
  LoadPCX('pcx/text_red.pcx',5,81,imgDummy,-1,true);
  LoadPCX('pcx/text_green.pcx',5,86,imgDummy,-1,true);
  LoadPCX('pcx/text_blue.pcx',5,91,imgDummy,-1,true);
  LoadPCX('pcx/text_yellow.pcx',5,96,imgDummy,-1,true);

  { 101-105, 106-110, 111-115, 116-120: Status obrazky (Zrava, Zmetena, Neviditelna, Tehlova }
  LoadPCX('pcx/status_zrava.pcx',5,101,imgStatusZrava,0,true);
  LoadPCX('pcx/status_zmetena.pcx',5,106,imgStatusZmetena,0,true);
  LoadPCX('pcx/status_neviditelna.pcx',5,111,imgStatusNeviditelna,0,true);
  LoadPCX('pcx/status_tehlova.pcx',5,116,imgStatusTehlova,0,true);
end;


procedure BeforeGame;
begin


end;

procedure AfterGame;
begin


end;

procedure ClearScreen;
begin
  clearviewport;
end;

procedure ClearStatus;
begin


end;

procedure SetMsg(var msgs:Tmsgs);
var i,d: integer;
begin

  with msgs.item[msgs.count] do
  begin
    if s='' then
    begin
      dec(msgs.count);
      exit;
    end;

    wid:=PCXTextWidth(s+'  ',font);
    s:=s+'    ';
    inv:=true;
    
    case col of
      1 : col:=40;
      2 : col:=45;
    end;
    
    { ak existuje hlaska hraca col, ktora este nie je zobrazena, zrus vsetky take }
    for i:=1 to msgs.count-1 do
     if ((msgs.item[i].col=col) and (msgs.item[i].xpos>640)) then msgs.item[i].s:='';
  end;
  
  d:=0;
  for i:=1 to msgs.count do
   if msgs.item[i].s<>'' then
   begin
     inc(d);
     if d<i then msgs.item[d]:=msgs.item[i];
   end;
  msgs.count:=d;
      

  if msgs.count>1 then msgs.item[msgs.count].xpos:=max(640,msgs.item[msgs.count-1].xpos+msgs.item[msgs.count-1].wid+20)
		  else msgs.item[msgs.count].xpos:=640;


end;

procedure ShowMsgs(var msgs:Tmsgs);
var x,y,i,d: integer;
    s:string;
begin

{  IQ_start;
  for y:=0 to 30 do
   for x:=0 to 639 do IQ_pixel(x,y,0);}

  for i:=1 to msgs.count do
  begin
    dec(msgs.item[i].xpos,msgs_speed);
    if msgs.item[i].xpos+msgs.item[i].wid<0 then
      msgs.item[i].s:=''
    else
      if msgs.item[i].xpos<640 then PrintPCXtext2(msgs.item[i].xpos,20,msgs.item[i].s,font,msgs.item[i].col,msgs.item[i].inv);
  end;

  d:=0;
  for i:=1 to msgs.count do
   if msgs.item[i].s<>'' then
   begin
     inc(d);
     if d<i then msgs.item[d]:=msgs.item[i];
   end;
  msgs.count:=d;
  
{  IQ_finish;}

end;


procedure QQSort(base: pointer; nmemb: longint; size: longint; compar:Tcmpfunction; l, r: Integer);
var
 i,j: integer;
    x,y: pointer;
begin
  i:=l; j:=r;
  getmem(x,size);
  getmem(y,size);
  move(pointer(longint(base)+((l+r) DIV 2)*size)^,x^,size);
  repeat
    while compar(pointer(longint(base)+i*size),x)<0 do inc(i);
    while compar(x,pointer(longint(base)+j*size))<0 do dec(j);
    if i<=j then
    begin
      move(pointer(longint(base)+i*size)^,y^,size);
      move(pointer(longint(base)+j*size)^,pointer(longint(base)+i*size)^,size);
      move(y^,pointer(longint(base)+j*size)^,size);
      
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then QQSort(base,nmemb,size,compar,l,j);
  if i<r then QQSort(base,nmemb,size,compar,i,r);
  freemem(x);
  freemem(y);
end;

procedure Qsort(base: pointer; nmemb: longint; size: longint; compar:Tcmpfunction);
begin
  QQSort(base,nmemb,size,compar,0,nmemb-1);
end;

function cmp(a,b: pointer): integer;
var ta,tb: Tiq;
begin
  ta:=Tiq(Piq(a)^);
  tb:=Tiq(Piq(b)^);
  if ta.x=tb.x then
  begin
    if ta.y=tb.y then cmp:=0
		 else cmp:=ta.y-tb.y;
  end
  else cmp:=ta.x-tb.x;
end;

procedure IQ_start;
begin
  IQ_active:=true;

{$IFDEF IQ0}
  IQ_count:=0;
{$ENDIF}
  
{$IFDEF IQ1}
  IQ_count:=0;
{$ENDIF}
  
{$IFDEF IQ2}
  fillchar(IQ_img,sizeof(IQ_img),255);
  IQ_minx:=0;
  IQ_maxx:=639;
  IQ_miny:=0;
  IQ_maxy:=479;
{$ENDIF}
end;

procedure IQ_finish;
var i: longint;
    last_x,last_y,last_c: integer;
    x,y,yy: longint;
    ff: text;
begin
{$IFDEF LOGS} assign(ff,'aaa'); append(ff); writeln(ff,IQ_count); close(ff); {$ENDIF}
  IQ_active:=false;

{$IFDEF IQ0}
  for i:=0 to IQ_count-1 do
  begin
    putpixel(IQ_list[i].x,IQ_list[i].y,IQ_list[i].col);
  end;
{$ENDIF}  

{$IFDEF IQ1}
  Qsort(@IQ_list,IQ_count,sizeof(Tiq),@cmp);
  
  IQ_list[IQ_count].x:=7777;
  IQ_list[IQ_count].y:=7777;
  IQ_list[IQ_count].y:=177;
  
  last_x:=IQ_list[0].x; last_y:=IQ_list[0].y; last_c:=IQ_list[0].col;
  i:=0;
  while i<IQ_count do
  begin
    while ((last_x=IQ_list[i].x) and (last_y=IQ_list[i].y)) do
    begin
      if IQ_list[i].col>last_c then last_c:=IQ_list[i].col;
      inc(i);
    end;
    if last_c=0 then 
      case global_mode of
        0,1 : last_c:=backimg.data^[640*last_y+last_x];
        7   : last_c:=introimg.data^[640*last_y+last_x];
	47  : last_c:=resultsimg.data^[640*last_y+last_x];
      end;
    if ((last_x>=0) and (last_x<640) and (last_y>=0) and (last_y<480)) then putpixel(last_x,last_y,last_c);
    last_x:=IQ_list[i].x;
    last_y:=IQ_list[i].y;
    last_c:=IQ_list[i].col;
  end;    
{$ENDIF}

{$IFDEF IQ2}
  for y:=IQ_miny to IQ_maxy do
  begin
   yy:=y*640;
   for x:=IQ_minx to IQ_maxx do
   begin
     case IQ_img[yy+x] of
       0   : ;
       255 : putpixel(x,y,backimg.data^[640*y+x]);
       else  putpixel(x,y,IQ_img[yy+x]);
     end;
   end;
  end;
{$ENDIF}
end;

procedure IQ_pixel(x,y,col: integer);
begin
{$IFDEF IQ0}
  IQ_list[IQ_count].x:=x;
  IQ_list[IQ_count].y:=y;
  IQ_list[IQ_count].col:=col;
  inc(IQ_count);
{$ENDIF}

{$IFDEF IQ1}
  IQ_list[IQ_count].x:=x;
  IQ_list[IQ_count].y:=y;
  IQ_list[IQ_count].col:=col;
  inc(IQ_count);
{$ENDIF}

{$IFDEF IQ2}
  if ((IQ_img[640*y+x]<255) and (IQ_img[640*y+x]>col)) then exit;
  
  if x<IQ_minx then IQ_minx:=x;
  if x>IQ_maxx then IQ_maxx:=x;
  if y<IQ_miny then IQ_miny:=y;
  if y>IQ_maxy then IQ_maxy:=y;
  IQ_img[640*y+x]:=col;
{$ENDIF}
end;

procedure IQ_line(x0,y0,x1,y1, col: integer);
var i, deltax, deltay, numpixels,
    d, dinc1, dinc2,
    x, xinc1, xinc2,
    y, yinc1, yinc2 : integer;
    
begin
  { Calculate deltax and deltay for initialisation }
  deltax := abs(x1 - x0);
  deltay := abs(y1 - y0);

  { Initialize all vars based on which is the independent variable }
  if deltax >= deltay then
    begin
      { x is independent variable }
      numpixels := deltax + 1;
      d := (2 * deltay) - deltax;
      dinc1 := deltay Shl 1;
      dinc2 := (deltay - deltax) shl 1;
      xinc1 := 1;
      xinc2 := 1;
      yinc1 := 0;
      yinc2 := 1;
    end
  else
    begin

      { y is independent variable }
      numpixels := deltay + 1;
      d := (2 * deltax) - deltay;
      dinc1 := deltax Shl 1;
      dinc2 := (deltax - deltay) shl 1;
      xinc1 := 0;
      xinc2 := 1;
      yinc1 := 1;
      yinc2 := 1;
    end;

  { Make sure x and y move in the right directions }
  if x0 > x1 then
    begin
      xinc1 := - xinc1;
      xinc2 := - xinc2;
    end;
  if y0 > y1 then
    begin
      yinc1 := - yinc1;
      yinc2 := - yinc2;
    end;

  { Start drawing at <x1, y1> }
  x := x0;
  y := y0;

  { Draw the pixels }
  for i := 1 to numpixels do
    begin
      IQ_pixel(x, y, col);
      IQ_pixel(x+yinc1, y+xinc1, col);
      IQ_pixel(x-yinc1, y-xinc1, col);
      if d < 0 then
        begin
          d := d + dinc1;
          x := x + xinc1;
          y := y + yinc1;
        end
      else
        begin
          d := d + dinc2;
          x := x + xinc2;
          y := y + yinc2;
        end;
    end;
end;

procedure DrawColor(c:integer);
var y,x: integer;
begin
  for y:=0 to 479 do
   for x:=0 to 639 do putpixel(x,y,c);
end;

procedure CrossColor(c:integer);
var x,y:integer;
begin
  for x:=319 downto 0 do
  begin
    for y:=0 to 239 do 
    begin
      putpixel(2*x,2*y,c); 
      putpixel(639-2*x,2*y+1,c); 
    end;
    if x mod SPEED_HORIZ=1 then delay(1); 
  end;

  for y:=0 to 239 do
  begin
    for x:=0 to 319 do 
    begin
      putpixel(2*x+1,2*y,c); 
      putpixel(2*x,479-2*y,c); 
    end;
    if y mod SPEED_VERT=1 then delay(1); 
  end;
end;

procedure CrossBMP(s:string; o:integer);
var pal:Tpal;
    f:file;
    img:Pimage;
    x,y:longint;
    cols:byte;
begin
  assign(f,s);
  {$I-}
  reset(f,1);
  {$I+}
  if IOresult<>0 then exit;
  
  blockread(f,pal,54);
  cols:=pal[46];
  blockread(f,pal,4*cols);
  setpalettepartial(pal,cols,o);
  
  new(img);
  seek(f,54+4*cols);
  for y:=479 downto 0 do blockread(f,img^[y*640],640);

  for x:=319 downto 0 do
  begin
    for y:=0 to 239 do 
    begin
      putpixel(2*x,2*y,o+img^[640*2*y+2*x]); 
      putpixel(639-2*x,2*y+1,o+img^[640*(2*y+1)+639-2*x]); 
    end;
    if x mod SPEED_HORIZ=1 then delay(1); 
  end;

  for y:=0 to 239 do
  begin
    for x:=0 to 319 do 
    begin
      putpixel(2*x+1,2*y,o+img^[640*2*y+2*x+1]); 
      putpixel(2*x,479-2*y,o+img^[640*(479-2*y)+2*x]); 
    end;
    if y mod SPEED_VERT=1 then delay(1); 
  end;
  
  dispose(img);
  close(f);
end;

procedure disposeimg(img:Timg);
begin
  FreeMem(img.pal,768);
  FreeMem(img.data,img.width*img.height);
end;

procedure CrossPCX(s:string; cols,o:integer);
var img: Timg;
begin
  LoadPCX(s,cols,o,img,-1,true);
  CrossPCX(img,cols,o);
  disposeimg(img);
end;

procedure CrossPCX(img:Timg; cols,o:integer);
var i,x,y: integer;
begin
  if img.data=nil then exit;
  { restore pal }
  for i:=0 to cols-1 do
    setRGB(o+i,img.pal^[3*i],img.pal^[3*i+1],img.pal^[3*i+2]);
  
  for x:=319 downto 0 do
  begin
    for y:=0 to 239 do 
    begin
      putpixel(2*x,2*y,img.data^[640*2*y+2*x]); 
      putpixel(639-2*x,2*y+1,img.data^[640*(2*y+1)+639-2*x]); 
    end;
    if x mod SPEED_HORIZ=1 then delay(1); 
  end;

  for y:=0 to 239 do
  begin
    for x:=0 to 319 do 
    begin
      putpixel(2*x+1,2*y,img.data^[640*2*y+2*x+1]); 
      putpixel(2*x,479-2*y,img.data^[640*(479-2*y)+2*x]); 
    end;
    if y mod SPEED_VERT=1 then delay(1); 
  end;
end;

procedure LoadPCX(s:string; cols,o:integer; var img:Timg; trans:integer; setpal:boolean);
var fp:longint;
    f:file;
    ff:text;
    header:PCXheader;
    data:array[0..2047] of byte;
    index:integer;
    colors:longint;

    i,count,linepaddingsize,pixelsperbyte:integer;
    x,y:longint;
    a,b:byte;

 function GetByte:byte;
 var done:integer;
 begin
     inc(index);
     if ((index=0) or (index>=1024)) then
     begin
          index:=0;
          BlockRead(f,data,1024,done);
     end;
     GetByte:=data[index];
 end;

begin
  img.width:=0;
  img.height:=0;
  img.data:=nil;
  img.pal:=nil;

  assign(f,s);
  {$I-}
  reset(f,1);
  {$I+}
  if IOresult<>0 then exit;

  {$IFDEF LOGS} assign(ff,'aaa'); append(ff); writeln(ff,'LoadPCX: ',s,', cols ',cols,', offs ',o); close(ff); {$ENDIF}
  
   
  BlockRead(f,header,128);
  if header.Identifier<>$0A then begin close(f); exit; end;

  header.XEnd:=header.XEnd-header.XStart+1;
  header.YEnd:=header.YEnd-header.YStart+1;
  colors:=1 shl (header.BitsPerPixel*header.NumBitPlanes);
  
  img.width:=header.Xend;
  img.height:=header.Yend;
  img.cols:=cols;
  img.offs:=o;
  if trans>=0 then img.trans:=o+trans;
  
  GetMem(img.pal,768);
  GetMem(img.data,img.width*img.height);

  { len 256 farebne obrazky }
  if ((header.BitsPerPixel=8) and (header.NumBitPlanes=1)) then else begin close(f); exit; end;

{  ProcessColorMap(cols,o);
 }
   fp:=FilePos(f);
   seek(f,filesize(f)-769);
   blockread(f,data,769);
   seek(f,fp);
   system.move(data[1],img.pal^[0],768);

   if ((data[0]=$0C) and (setpal)) then
   begin
     for i:=0 to cols-1 do
       setRGB(o+i,data[3*i+1],data[3*i+2],data[3*i+3]);
   end;

{  ProcessData(cols,o);
 }
     PixelsPerByte:=8 div header.BitsPerPixel;
     LinePaddingSize:=(header.BytesPerLine*header.NumBitPlanes)*(8 div header.BitsPerPixel)-header.XEnd;
     LinePaddingSize:=LinePaddingSize div PixelsPerByte;

     index:=-1;
     y:=0;
     x:=0;
     Repeat
           a:=GetByte;
           If (a and $C0) = $C0 then
           Begin
                count:=a and $3F;
                b:=GetByte;
           End
           Else
           Begin
                count:=1;
                b:=a;
           End;

           For i:=1 to count do
           Begin
                img.data^[img.width*y+x]:=o+b;
                inc(x);
                If x*PixelsPerByte>=header.XEnd then
                Begin
                     inc(y);
                     x:=0;
                     inc(index,LinePaddingSize);
                     If y>=header.YEnd then break;
                End;
           End;
     Until y>=header.YEnd;

  close(f);
end;


procedure DrawPCX(s:string; dx,dy,cols,o,trans:integer);
var fp:longint;
    f:file;
    header:PCXheader;
    data:array[0..2047] of byte;
    index:integer;
    colors:longint;

    i,count,linepaddingsize,pixelsperbyte:integer;
    x,y:longint;
    a,b:byte;

 function GetByte:byte;
 var done:integer;
 begin
     inc(index);
     if ((index=0) or (index>=1024)) then
     begin
          index:=0;
          BlockRead(f,data,1024,done);
     end;
     GetByte:=data[index];
 end;

begin
  assign(f,s);
  {$I-}
  reset(f,1);
  {$I+}
  if IOresult<>0 then exit;

   
  BlockRead(f,header,128);
  if header.Identifier<>$0A then begin close(f); exit; end;

  header.XEnd:=header.XEnd-header.XStart+1;
  header.YEnd:=header.YEnd-header.YStart+1;
  colors:=1 shl (header.BitsPerPixel*header.NumBitPlanes);

  { len 256 farebne obrazky }
  if ((header.BitsPerPixel=8) and (header.NumBitPlanes=1)) then else begin close(f); exit; end;

{  ProcessColorMap(cols,o);
 }
   fp:=FilePos(f);
   seek(f,filesize(f)-769);
   blockread(f,data,769);
   seek(f,fp);
   if data[0]=$0C then
   begin
        for i:=0 to cols-1 do
	  setRGB(o+i,data[3*i+1],data[3*i+2],data[3*i+3]);
   end;

{  ProcessData(cols,o);
 }
     PixelsPerByte:=8 div header.BitsPerPixel;
     LinePaddingSize:=(header.BytesPerLine*header.NumBitPlanes)*(8 div header.BitsPerPixel)-header.XEnd;
     LinePaddingSize:=LinePaddingSize div PixelsPerByte;

     index:=-1;
     y:=0;
     x:=0;
     Repeat
           a:=GetByte;
           If (a and $C0) = $C0 then
           Begin
                count:=a and $3F;
                b:=GetByte;
           End
           Else
           Begin
                count:=1;
                b:=a;
           End;

           For i:=1 to count do
           Begin
                if b<>trans then
		  putpixel(dx+x,dy+y,o+b);
		  
                inc(x);
                If x*PixelsPerByte>=header.XEnd then
                Begin
                     inc(y);
                     x:=0;
                     inc(index,LinePaddingSize);
                     If y>=header.YEnd then break;
                End;
           End;
     Until y>=header.YEnd;

  close(f);
  colors:=colors;
end;

procedure DrawPCX_IQ(s:string; dx,dy,cols,o,trans:integer);
var fp:longint;
    f:file;
    header:PCXheader;
    data:array[0..2047] of byte;
    index:integer;
    colors:longint;

    i,count,linepaddingsize,pixelsperbyte:integer;
    x,y:longint;
    a,b:byte;

 function GetByte:byte;
 var done:integer;
 begin
     inc(index);
     if ((index=0) or (index>=1024)) then
     begin
          index:=0;
          BlockRead(f,data,1024,done);
     end;
     GetByte:=data[index];
 end;

begin
  assign(f,s);
  {$I-}
  reset(f,1);
  {$I+}
  if IOresult<>0 then exit;

   
  BlockRead(f,header,128);
  if header.Identifier<>$0A then begin close(f); exit; end;

  header.XEnd:=header.XEnd-header.XStart+1;
  header.YEnd:=header.YEnd-header.YStart+1;
  colors:=1 shl (header.BitsPerPixel*header.NumBitPlanes);

  { len 256 farebne obrazky }
  if ((header.BitsPerPixel=8) and (header.NumBitPlanes=1)) then else begin close(f); exit; end;

{  ProcessColorMap(cols,o);
 }
   fp:=FilePos(f);
   seek(f,filesize(f)-769);
   blockread(f,data,769);
   seek(f,fp);
   if data[0]=$0C then
   begin
        for i:=0 to cols-1 do
	  setRGB(o+i,data[3*i+1],data[3*i+2],data[3*i+3]);
   end;

{  ProcessData(cols,o);
 }
     PixelsPerByte:=8 div header.BitsPerPixel;
     LinePaddingSize:=(header.BytesPerLine*header.NumBitPlanes)*(8 div header.BitsPerPixel)-header.XEnd;
     LinePaddingSize:=LinePaddingSize div PixelsPerByte;

     index:=-1;
     y:=0;
     x:=0;
     Repeat
           a:=GetByte;
           If (a and $C0) = $C0 then
           Begin
                count:=a and $3F;
                b:=GetByte;
           End
           Else
           Begin
                count:=1;
                b:=a;
           End;

           For i:=1 to count do
           Begin
                if b<>trans then
		  IQ_pixel(dx+x,dy+y,o+b);
		  
                inc(x);
                If x*PixelsPerByte>=header.XEnd then
                Begin
                     inc(y);
                     x:=0;
                     inc(index,LinePaddingSize);
                     If y>=header.YEnd then break;
                End;
           End;
     Until y>=header.YEnd;

  close(f);
  colors:=colors;
end;


procedure DrawBMP(s:string; ww,hh,dx,dy,o,trans:integer);
var pal:Tpal;
    f:file;
    x,y,www:longint;
    cols:byte;
begin
  assign(f,s);
  {$I-}
  reset(f,1);
  {$I+}
  if IOresult<>0 then exit;
  
  blockread(f,pal,54);
  cols:=pal[46];
  blockread(f,pal,4*cols);
  setpalettepartial(pal,cols,o);
  
  seek(f,54+4*cols);
  www:=((ww+3) div 4)*4;
  for y:=hh-1 downto 0 do
  begin
    blockread(f,pal,www);
    for x:=0 to ww-1 do 
     if pal[x]<>trans then putpixel(dx+x,dy+y,o+pal[x]);
  end;

  close(f);
end;

procedure PrintPCXText(x,y: integer; s:string; fnt:Tfont);
begin
  PrintPCXText(x,y,s,fnt,250,false);
end;

procedure PrintPCXText(x,y: integer; s:string; fnt:Tfont; o:integer; inv: boolean);
var xx,xxx,yy,yyy,i: integer;
begin
  for i:=1 to length(s) do
  begin
    yyy:=fnt.row[fnt.chars[s[i]].row].top-fnt.row[fnt.chars[s[i]].row].base;
    for yy:=fnt.row[fnt.chars[s[i]].row].top to fnt.row[fnt.chars[s[i]].row].bot do
    begin
      xxx:=-1;
      for xx:=fnt.row[fnt.chars[s[i]].row].col[fnt.chars[s[i]].col].left-1 to fnt.row[fnt.chars[s[i]].row].col[fnt.chars[s[i]].col].right+1 do
      begin
{$IFDEF IQ}
{        if fnt.img.data^[640*yy+xx]<>fnt.img.data^[0] then IQ_pixel(x+xxx,y+yyy,fnt.img.data^[640*yy+xx]);}
        if ((fnt.img.data^[640*yy+xx]<>fnt.img.data^[0]) or 
	    (fnt.img.data^[640*(yy-1)+xx]<>fnt.img.data^[0]) or
	    (fnt.img.data^[640*(yy+1)+xx]<>fnt.img.data^[0]) or
	    (fnt.img.data^[640*(yy)+xx-1]<>fnt.img.data^[0]) or
	    (fnt.img.data^[640*(yy)+xx+1]<>fnt.img.data^[0]))
	 then 
	 begin
	   if inv then IQ_pixel(x+xxx,y+yyy,4-(fnt.img.data^[640*yy+xx]-250)+o)
		  else IQ_pixel(x+xxx,y+yyy,fnt.img.data^[640*yy+xx]-250+o);
	 end;

{$ELSE}
        if fnt.img.data^[640*yy+xx]<>fnt.img.data^[0] then putpixel(x+xxx,y+yyy,fnt.img.data^[640*yy+xx]);
{$ENDIF}
        inc(xxx);
      end;
      inc(yyy);
    end;
    inc(x,xxx);
  end;
end;

procedure PrintPCXText2(x,y: integer; s:string; fnt:Tfont; o:integer; inv: boolean);
var xx,xxx,yy,yyy,i: integer;
begin
  for i:=1 to length(s) do
  begin
    yyy:=fnt.row[fnt.chars[s[i]].row].top-fnt.row[fnt.chars[s[i]].row].base-fnt.maxdepth;
    for yy:=fnt.row[fnt.chars[s[i]].row].top-fnt.maxdepth to fnt.row[fnt.chars[s[i]].row].bot+fnt.maxdepth do
    begin
      xxx:=-1;
      for xx:=fnt.row[fnt.chars[s[i]].row].col[fnt.chars[s[i]].col].left-1 to fnt.row[fnt.chars[s[i]].row].col[fnt.chars[s[i]].col].right+1 do
      begin
{$IFDEF IQ}
{        if fnt.img.data^[640*yy+xx]<>fnt.img.data^[0] then IQ_pixel(x+xxx,y+yyy,fnt.img.data^[640*yy+xx]);}
        if ((fnt.img.data^[640*yy+xx]<>fnt.img.data^[0]) or 
	    (fnt.img.data^[640*(yy-1)+xx]<>fnt.img.data^[0]) or
	    (fnt.img.data^[640*(yy+1)+xx]<>fnt.img.data^[0]) or
	    (fnt.img.data^[640*(yy)+xx-1]<>fnt.img.data^[0]) or
	    (fnt.img.data^[640*(yy)+xx+1]<>fnt.img.data^[0]))
	 then 
	 begin
	   if inv then putpixel(x+xxx,y+yyy,4-(fnt.img.data^[640*yy+xx]-250)+o)
		  else putpixel(x+xxx,y+yyy,fnt.img.data^[640*yy+xx]-250+o);
	 end
	 else
	 begin
	   putpixel(x+xxx,y+yyy,backimg.data^[640*(y+yyy)+xxx+x]);
	 end;

{$ELSE}
        if fnt.img.data^[640*yy+xx]<>fnt.img.data^[0] then putpixel(x+xxx,y+yyy,fnt.img.data^[640*yy+xx]);
{$ENDIF}
        inc(xxx);
      end;
      inc(yyy);
    end;
    inc(x,xxx);
  end;
end;

function PCXTextWidth(s:string; fnt:Tfont): integer;
var x,xxx,i:integer;
begin
  x:=0;
  for i:=1 to length(s) do
  begin
    xxx:=fnt.row[fnt.chars[s[i]].row].col[fnt.chars[s[i]].col].right-fnt.row[fnt.chars[s[i]].row].col[fnt.chars[s[i]].col].left+2;
    inc(x,xxx);
  end;
  PCXTextWidth:=x;
end;

procedure ParsePCXfont(img: Timg; y_skip: integer; var fnt: Tfont);
var r,c,x,y,i,j: longint;
    ok,blank: boolean;
    left1,right1: longint;
    ymin: longint;
begin
  { 1: najdi lavy okraj }
  x:=0;
  repeat
    ok:=false; 
    for y:=0 to 479 do
     if img.data^[640*y+x]<>img.data^[0] then begin ymin:=y+1; inc(x); left1:=x; ok:=true; break; end;
    if ok then break;
    inc(x);
  until x>=640;

  while img.data^[640*ymin+x]<>img.data^[0] do inc(x);
  dec(x,2);
  right1:=x;
  fnt.maxdepth:=0;
  
{  for y:=0 to 479 do putpixel(left1,y,14);
  for y:=0 to 479 do putpixel(right1,y,13); }

  { 2: urci riadky }
  fnt.rows:=0;
  y:=0;
  repeat
    inc(fnt.rows);
    fnt.row[fnt.rows].wid:=-1;
    while img.data^[640*y+left1]=img.data^[0] do 
    begin
      blank:=true; for x:=0 to 479 do if img.data^[640*y+x]<>img.data^[0] then blank:=false;
      if ((not blank) and (fnt.row[fnt.rows].wid<0)) then
      begin
        fnt.row[fnt.rows].wid:=y+1;
      end;
      inc(y);
      if y>=480 then break;
    end;  
    if y>=480 then break;
    
    fnt.row[fnt.rows].top:=y-1;
    fnt.row[fnt.rows].base:=-1;
    inc(y,y_skip);
    while img.data^[640*y+left1]<>img.data^[0] do 
    begin
      if ((fnt.row[fnt.rows].base<0) and (img.data^[640*y+right1]=img.data^[0])) then fnt.row[fnt.rows].base:=y-1;
      inc(y);
    end;  
    fnt.row[fnt.rows].bot:=y;
    if fnt.row[fnt.rows].base<0 then fnt.row[fnt.rows].base:=fnt.row[fnt.rows].bot-1;

    if fnt.row[fnt.rows].bot-fnt.row[fnt.rows].base>fnt.maxdepth then
      fnt.maxdepth:=fnt.row[fnt.rows].bot-fnt.row[fnt.rows].base+1;
      
    inc(y,y_skip);
    
  until false;

{  for i:=1 to rows do
  begin
    for x:=0 to 639 do 
    begin
      putpixel(x,row[i].wid,8);
      putpixel(x,row[i].top,9);
      putpixel(x,row[i].base,10);
      putpixel(x,row[i].bot,14);
    end; 
  end; }
  
  { 3: pre kazdy riadok urci sirky jednotlivych znakov }
  for i:=1 to fnt.rows do
  begin
    x:=0;
    repeat
      while img.data^[640*fnt.row[i].wid+x]=img.data^[0] do
      begin
        inc(x);
        if x>=640 then break;
      end;
      if x>=640 then break;
      
      inc(fnt.row[i].cols);
      fnt.row[i].col[fnt.row[i].cols].left:=x;
      while img.data^[640*fnt.row[i].wid+x]<>img.data^[0] do inc(x);
      fnt.row[i].col[fnt.row[i].cols].right:=x-1;
      
{      for j:=fnt.row[i].top to fnt.row[i].bot do
      begin
        putpixel(fnt.row[i].col[row[i].cols].left,j,11);
        putpixel(fnt.row[i].col[row[i].cols].right,j,12);
      end; }
    until false;
  end;

  { 4: generate chars table }  
  r:=1; c:=1;
  for i:=1 to length(chartab) do
  begin
    fnt.chars[chartab[i]].row:=r;
    fnt.chars[chartab[i]].col:=c;
    inc(c);
    if c>fnt.row[r].cols then
    begin
      c:=1;
      inc(r);
    end;
  end;
  
  fnt.img:=img;
end;


procedure ShowIntro;
begin
end;

procedure ShowOutro;
begin
end;


procedure DrawScore(dx,dy:integer; sc:longint);
var s:string;

    i:integer;

begin
  s:=IntToStr(sc);

  for i:=length(s) downto 1 do
  begin
    dec(dx,30);
    DrawPCX('bmp/digit'+s[i]+'.pcx',dx,dy,5,250,0);
  end;

end;


function kdelay2(t:longint):boolean;
begin
  kdelay2:=false;
  while t>0 do
  begin
    delay(min(t,100));
    dec(t,100);
    if keypressed then
    begin
      kdelay2:=true;
      break;
    end;
  end;
end;

function kdelay(t:longint):boolean;
begin
  kdelay:=false;
  while t>0 do
  begin
    delay(min(t,100));
    dec(t,100);
    if keypressed then
    begin
      kdelay:=true;
      while keypressed do readkey;
      break;
    end;
  end;
end;

procedure disp_Done;
begin

  if need_cls then CrossColor(0);

  CloseGraph;
end;

procedure DrawIMG(img:Timg; dx,dy:integer);
begin
  DrawIMG(img,dx,dy,img.offs);
end;

procedure DrawIMG(img:Timg; dx,dy:integer; palshift:integer);
var x,y,ind: longint;
begin
  if img.data=nil then exit;
  
  if IQ_active then
  begin
    for y:=0 to img.height-1 do  
      for x:=0 to img.width-1 do 
      begin
        ind:=img.width*y+x;
        if img.data^[ind]<>img.trans then IQ_Pixel(x+dx,y+dy,img.data^[ind]+palshift-img.offs);
      end;
  end
  else
  begin
    for y:=0 to img.height-1 do  
      for x:=0 to img.width-1 do 
      begin
        ind:=img.width*y+x;
        if img.data^[ind]<>img.trans then PutPixel(x+dx,y+dy,img.data^[ind]+palshift-img.offs);
      end;
  end;
end;

procedure HideIMG(img:Timg; dx,dy:integer);
var x,y,ind: longint;
begin
  if IQ_active then
  begin
    for y:=0 to img.height-1 do
      for x:=0 to img.width-1 do 
      begin
        ind:=640*(y+dy)+x+dx;
        IQ_Pixel(x+dx,y+dy,0);
      end;
  end
  else
  begin
    for y:=0 to img.height-1 do
      for x:=0 to img.width-1 do 
      begin
        ind:=640*(y+dy)+x+dx;
        PutPixel(x+dx,y+dy,backimg.data^[ind]);
      end;
  end;
end;

function mkX(x:integer): integer;
begin
  mkX:=xoff+(x-1)*SIZE_X;
end;

function mkY(y:integer): integer;
begin
  mkY:=yoff+(y-1)*SIZE_Y
end;

procedure ShowField(data:Pdata; x,y: integer);
var l: longint;
    i: integer;
begin
  l:=data^.plan[x,y];
  
  { stena }
  if l and vStena<>0 then DrawIMG(imgStena,mkX(x),mkY(y));

  { fazulky }
  if l and vfZlata<>0 then DrawIMG(imgfZlata,mkX(x),mkY(y));
  if l and vfZrava<>0 then DrawIMG(imgfZrava,mkX(x),mkY(y));
  if l and vfTehlova<>0 then DrawIMG(imgfTehlova,mkX(x),mkY(y));
  if l and vfZmetena<>0 then DrawIMG(imgfZmetena,mkX(x),mkY(y));
  if l and vfNeviditelna<>0 then DrawIMG(imgfNeviditelna,mkX(x),mkY(y));
  if l and vfTyckova<>0 then DrawIMG(imgfTyckova,mkX(x),mkY(y));
  if l and vfOtaznik<>0 then DrawIMG(imgfOtaznik,mkX(x),mkY(y));
  
  { hraci, slimaci }
  if l and vPlayer1<>0 then DrawIMG(imgPl[1,data^.pl[1].dir],mkX(x),mkY(y));
  if l and vPlayer2<>0 then DrawIMG(imgPl[2,data^.pl[2].dir],mkX(x),mkY(y));
  if l and vPlayer3<>0 then DrawIMG(imgPl[3,data^.pl[3].dir],mkX(x),mkY(y));
  if l and vPlayer4<>0 then DrawIMG(imgPl[4,data^.pl[4].dir],mkX(x),mkY(y));

  if l and vSlimak<>0 then 
  begin
    for i:=5 to MAX_PLAYERS do
     if ((data^.pl[i].x=x) and (data^.pl[i].y=y)) then
      DrawIMG(imgPl[i,data^.pl[i].dir],mkX(x),mkY(y));
  end;
end;

procedure ShowPlan(data:Pdata; fast:boolean);
var x,y: integer;
begin
  if not fast then CrossPCX(backimg,backimg.cols,backimg.offs);
  
  for y:=1 to MAX_PLAN_Y do
   for x:=1 to MAX_PLAN_X do ShowField(data,x,y);
end;

procedure ShowData(data:Pdata; pl:integer);
begin
  ShowData(data,pl,false);
end;

procedure ShowData(data:Pdata; pl:integer; fast: boolean);
var w,dx,dy,i,j,x0,x1,y0,xbase: integer;
    ff: text;
    s: string;
begin
  if pl>4 then exit;
  
  IQ_start;
  
  case pl of
    1 : begin xbase:=0; x0:=0; x1:=PCXTextWidth(data^.pl[pl].name,font)+10; y0:=18; dx:=1; dy:=1; end;
    2 : begin xbase:=639; x0:=639-PCXTextWidth(data^.pl[pl].name,font); x1:=x0-2-30; y0:=18; dx:=-1; dy:=1; end;
    3 : begin xbase:=0; x0:=0; x1:=PCXTextWidth(data^.pl[pl].name,font)+10; y0:=474; dx:=1; dy:=-1; end;
    4 : begin xbase:=639; x0:=639-PCXTextWidth(data^.pl[pl].name,font); x1:=x0-2-30; y0:=474; dx:=-1; dy:=-1; end;
  end;

  { erase old hits }
  {$IFDEF LOGS} assign(ff,'aaa'); append(ff); writeln(ff,'ShowData: pl=',pl,', x1=',x1,', y0=',y0,', left=',data^.pl[pl].left); close(ff); {$ENDIF}
  
  if not fast then
  begin
    for i:=0 to data^.pl[pl].left do
      HideIMG(imgHeart,x1+dx*30*i,y0-16);

    { show new hits }  
    for i:=0 to data^.pl[pl].left-1 do
      DrawIMG(imgHeart,x1+dx*30*i,y0-16,playerpal[pl]);

    { meno hraca }
    PrintPCXText(x0,y0,data^.pl[pl].name,font);
  end;

  { zobraz score, ak sa zmenilo od minula }  
  if ((old_score[pl].score<>data^.pl[pl].score) or (not fast)) then
  begin
    s:=IntToStr(data^.pl[pl].score);
    w:=PCXTextWidth(IntToStr(old_score[pl].score),font);
    
    for j:=-1 to 17 do
     for i:=0 to w+1 do IQ_Pixel(xbase+dx*i,y0+dy*20-j,0);
     
    if odd(pl) then PrintPCXText(xbase,y0+dy*20,s,font,76+5*pl,true)
	       else PrintPCXText(xbase-PCXTextWidth(s,font),y0+dy*20,s,font,76+5*pl,true);

    old_score[pl].score:=data^.pl[pl].score;
  end;

  { zobraz stav (viditelnost, zravost, zmetenost) }
  if ((data^.pl[pl].nZrava=0) and (old_score[pl].nZrava>0)) then HideIMG(imgStatusZrava,xbase+(dx-1)*20,y0+dy*60-(dy+1)*19); if ((data^.pl[pl].nZrava>0) and (old_score[pl].nZrava=0)) then DrawIMG(imgStatusZrava,xbase+(dx-1)*20,y0+dy*60-(dy+1)*19); old_score[pl].nZrava:=data^.pl[pl].nZrava; 
  if ((data^.pl[pl].nNeviditelna=0) and (old_score[pl].nNeviditelna>0)) then HideIMG(imgStatusNeviditelna,xbase+(dx-1)*20,y0+dy*80-(dy+1)*19); if ((data^.pl[pl].nNeviditelna>0) and (old_score[pl].nNeviditelna=0)) then DrawIMG(imgStatusNeviditelna,xbase+(dx-1)*20,y0+dy*80-(dy+1)*19); old_score[pl].nNeviditelna:=data^.pl[pl].nNeviditelna; 
  if ((data^.pl[pl].nZmetena=0) and (old_score[pl].nZmetena>0)) then HideIMG(imgStatusZmetena,xbase+(dx-1)*20,y0+dy*100-(dy+1)*19); if ((data^.pl[pl].nZmetena>0) and (old_score[pl].nZmetena=0)) then DrawIMG(imgStatusZmetena,xbase+(dx-1)*20,y0+dy*100-(dy+1)*19); old_score[pl].nZmetena:=data^.pl[pl].nZmetena; 
  if ((data^.pl[pl].nTehlova=0) and (old_score[pl].nTehlova>0)) then HideIMG(imgStatusTehlova,xbase+(dx-1)*20,y0+dy*120-(dy+1)*19); if ((data^.pl[pl].nTehlova>0) and (old_score[pl].nTehlova=0)) then DrawIMG(imgStatusTehlova,xbase+(dx-1)*20,y0+dy*120-(dy+1)*19); old_score[pl].nTehlova:=data^.pl[pl].nTehlova; 
  
  IQ_finish; 
end;

procedure ShowView(view:Tview; dy:integer);
begin
end;

procedure ShowActions(data:Pdata);
var i: integer;
begin
  IQ_start;
  for i:=1 to actions do
  begin
    case action[i].cmd of
      1 : HideIMG(imgStena,mkX(action[i].x),mkY(action[i].y));
      2 : ShowField(data,action[i].x,action[i].y);
      3 : if data^.plan[action[i].x,action[i].y] and vStena=0 then HideIMG(imgStena,mkX(action[i].x),mkY(action[i].y))
    	       else ShowField(data,action[i].x,action[i].y);
    end;
  end;
  IQ_finish;
  actions:=0;
end;

procedure ShowGameNo(game_no: integer);
var s:string;
begin
  DrawColor(0);
  s:='Game '+IntToStr(game_no);
  IQ_start;
  PrintPCXText(320-PCXTextWidth(s,font) div 2,240+10,s,font,81,true);
 
  IQ_finish;
  kdelay(2000);
  DrawColor(0);
end;

procedure ShowResults;
var i,j,q: integer;
    perm: array[1..10] of integer;
begin
  CrossColor(0);
  CrossPCX(resultsimg,200,50);

  { 21-40: farby pre texty }
  LoadPCX('pcx/text_red.pcx',5,21,imgDummy,-1,true);
  LoadPCX('pcx/text_green.pcx',5,26,imgDummy,-1,true);
  LoadPCX('pcx/text_blue.pcx',5,31,imgDummy,-1,true);
  LoadPCX('pcx/text_yellow.pcx',5,36,imgDummy,-1,true);

  for i:=1 to 4 do 
  begin
    perm[i]:=i;
  end;
  
  for i:=1 to 4 do
   for j:=i+1 to 4 do
   begin
     if vars.data^.pl[perm[i]].score>vars.data^.pl[perm[j]].score then
     begin
       q:=perm[i];
       perm[i]:=perm[j];
       perm[j]:=q;
     end;
   end;
  
  for i:=1 to 4 do
  begin
    kdelay(res_delay[i]);
    IQ_start;
    PrintPCXtext(320-PCXtextWidth(vars.data^.pl[perm[i]].name,font),420-70*i,vars.data^.pl[perm[i]].name,font,16+5*perm[i],true);
    PrintPCXtext(420,420-70*i,IntToStr(vars.data^.pl[perm[i]].score),font,16+5*perm[i],true);
    IQ_finish;
  end;
  
  kdelay(30000);
  CrossColor(0);
end;

begin
  erase:=false;
  IQ_active:=false;
  for i:=1 to MAX_PLAYERS do 
  begin
    old_score[i].score:=-1;
    old_score[i].nzrava:=0;
    old_score[i].nzmetena:=0;
    old_score[i].nneviditelna:=0;
    old_score[i].ntehlova:=0;
  end;
  backimg.data:=nil;
end.
