{ ENGINE Headers v1.3 by Darken (c) 2002 Latky-Polianky }

const
  StackSize         = 32;
  QueueSize	    = 2048;
  
  MaxPathLen	    = 128;
  
  ST_DEFAULT        = 000;
  ST_BASIC          = 001;
  ST_SAVEMAP	    = 002;
  ST_MOVE	    = 003;
  ST_EXPLORE	    = 004;
  ST_TUNEL	    = 005;
  
  vUnknown          = $10000000;
  
  Infty		    = 2000000;
  
  dx                : Array[0..3] of ShortInt = ( 0, 1, 0,-1);
  dy                : Array[0..3] of ShortInt = (-1, 0, 1, 0);


type

PState = ^TState;
TState = object
  Typ               : Integer;  

  constructor Init(T : Integer);
  destructor Done;
  function Run : Integer;
end;

THlubStack = object

  Data              : array[1..StackSize] of PState;
  Head              : Integer;
  
  procedure Init;
   
  { ----- stack operations ----- }
  procedure Clear;
  procedure Push(S : PState);
  function Pop : PState;
  function Empty : Boolean;  
  { ---------------------------- }
end;


{ ----------  TQueue ------------ }
TPos = record
  X,Y               : Integer;
end;

THlubQueue = object
  Data              : array[0..QueueSize] of TPos;
  Head,Tail	    : Integer;
  
  procedure Init;
  procedure Push(X,Y : Integer);
  procedure Pop(var X : Integer; var Y : Integer);
  function Empty : Boolean;
  
end;
{ ------------------------------- }


{ ------------------------------- }

PState_BASIC = ^TState_BASIC;
TState_BASIC = object(TState)
  function Exec : Integer;
end;

{ ------------------------------- }

PState_SAVEMAP = ^TState_SAVEMAP;
TState_SAVEMAP = object(TState)
  function Exec : Integer;
end;

{ ------------------------------- }

PState_MOVE = ^TState_MOVE;
TState_MOVE = object(TState)
  dstX,dstY     : Integer; { destination }
  Path          : array[1..MaxPathLen] of Integer;
  PLen,PPtr     : Integer; { path length, path pointer }

  Eating        : Boolean;
  Explore	: Boolean;
  Precount	: Boolean;

  function SetPath(X,Y : Integer) : Integer;
  function Exec : Integer;
end;

{ ------------------------------- }

PState_EXPLORE = ^TState_EXPLORE;
TState_EXPLORE = object(TState)
  function Exec : Integer;
end;

{ ------------------------------- }

PState_TUNEL = ^TState_TUNEL;
TState_TUNEL = object(TState)
  function Exec : Integer;
end;

{ ------------------------------- }

TMap = Array[0..MAX_PLAN_X+1,0..MAX_PLAN_Y+1] of Longint;
